/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001,2002 by Information-technology Promotion Agency, JAPAN
 *  Copyright (C) 2001,2002 by TRON Association, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2005-2010 by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2005-2006 by Japan Aerospace Exploration Agency.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ץå¸⥸塼 ֥MIPS32ѡ
 */

#define	_MACRO_ONLY
#include "hrp_kernel.h"
#include "offset.h"
#define daddiu addiu
#define dmfc0 mfc0
#define dmtc0 mtc0
#define ld lw
#define sd sw

	.set at
	.set reorder

	.section .text_unmapped, "ax"
	.align 2

/*
 *  ǥѥå
 *  dispatch ϡnontask_nest = 0CPUå(߶ػ)֤ǸƤӽФʤФʤʤ
 *  exit_and_dispatch ϡnontask_nest = 0CPUå(߶ػ)֤ǸƤӽФ
 */

	.global dispatch
	.global exit_and_dispatch

/* ǥѥåŪ˸ƤӽФ */
dispatch:
#ifdef SUPPORT_OVR
	ABI_PADDIU sp, sp, -ABI_STACK(1*ABI_GPR)
	sd ra, 0*ABI_GPR(sp)
	ABI_PLA v1, ovrtimer_stop
	jalr v1					/* Х󥿥ޤ */
	ld ra, 0*ABI_GPR(sp)
	ABI_PADDIU sp, sp, ABI_STACK(1*ABI_GPR)
#endif /* SUPPORT_OVR */
#if ABI_FPR == 0
	ABI_PADDIU    sp, sp, -ABI_STACK(11*ABI_GPR+4)
#else /* ABI_FPR == 8 */
	ABI_PADDIU    sp, sp, -ABI_STACK(11*ABI_GPR+6*ABI_FPR+8)
#endif
	sd      s0,  0*ABI_GPR(sp)		/* å쥸 */
	sd      s1,  1*ABI_GPR(sp)
	sd      s2,  2*ABI_GPR(sp)
	sd      s3,  3*ABI_GPR(sp)
	sd      s4,  4*ABI_GPR(sp)
	sd      s5,  5*ABI_GPR(sp)
	sd      s6,  6*ABI_GPR(sp)
	sd      s7,  7*ABI_GPR(sp)
	sd      gp,  8*ABI_GPR(sp)
	sd      s8,  9*ABI_GPR(sp)
	sd      ra, 10*ABI_GPR(sp)

#if ABI_FPR == 0
#else /* ABI_FPR == 8 */
	sdc1 $f20, 11*ABI_GPR+0*ABI_FPR(sp)
	sdc1 $f22, 11*ABI_GPR+1*ABI_FPR(sp)
	sdc1 $f24, 11*ABI_GPR+2*ABI_FPR(sp)
	sdc1 $f26, 11*ABI_GPR+3*ABI_FPR(sp)
	sdc1 $f28, 11*ABI_GPR+4*ABI_FPR(sp)
	sdc1 $f30, 11*ABI_GPR+5*ABI_FPR(sp)
	cfc1 t4, $31
	sw t4, 11*ABI_GPR+6*ABI_FPR(sp)
#endif

	ABI_PLA t4, rundom
	lw t5, (t4)
#if ABI_FPR == 0
	sw t5, 11*ABI_GPR(sp)
#else /* ABI_FPR == 8 */
	sw t5, 11*ABI_GPR+6*ABI_FPR+4(sp)
#endif

	ABI_PLA      a4, p_runtsk
	ABI_PLA      a6, dispatch_r
	ABI_PL      a5, (a4)		/* a5 = p_runtsk */
	ABI_PS      sp, TCB_sp(a5)		/* p_runtsk->sp = sp */
	ABI_PS      a6, TCB_pc(a5)		/* p_runtsk->pc = dispatch_r */
	b       dispatcher

/*
 *  ǥѥåи
 *  ǥѥåˤơa5 = p_runtsk ȤʤäƤ뤳Ȥ
 *  åݥ󥿤Ѥ
 */
dispatch_r: 
	ld      s0,  0*ABI_GPR(sp)		/* å쥸 */
	ld      s1,  1*ABI_GPR(sp)
	ld      s2,  2*ABI_GPR(sp)
	ld      s3,  3*ABI_GPR(sp)
	ld      s4,  4*ABI_GPR(sp)
	ld      s5,  5*ABI_GPR(sp)
	ld      s6,  6*ABI_GPR(sp)
	ld      s7,  7*ABI_GPR(sp)
	ld      gp,  8*ABI_GPR(sp)
	ld      s8,  9*ABI_GPR(sp)
	ld      ra, 10*ABI_GPR(sp)

#if ABI_FPR == 0
#else /* ABI_FPR == 8 */
	ldc1 $f20, 11*ABI_GPR+0*ABI_FPR(sp)
	ldc1 $f22, 11*ABI_GPR+1*ABI_FPR(sp)
	ldc1 $f24, 11*ABI_GPR+2*ABI_FPR(sp)
	ldc1 $f26, 11*ABI_GPR+3*ABI_FPR(sp)
	ldc1 $f28, 11*ABI_GPR+4*ABI_FPR(sp)
	ldc1 $f30, 11*ABI_GPR+5*ABI_FPR(sp)
	lw t4, 11*ABI_GPR+6*ABI_FPR(sp)
	ctc1 t4, $31
#endif

	ABI_PLA t4, rundom
#if ABI_FPR == 0
	lw t5, 11*ABI_GPR(sp)
#else /* ABI_FPR == 8 */
	lw t5, 11*ABI_GPR+6*ABI_FPR+4(sp)
#endif
	sw t5, (t4)
#if ABI_FPR == 0
	ABI_PADDIU    sp, sp, ABI_STACK(11*ABI_GPR+4)
#else /* ABI_FPR == 8 */
	ABI_PADDIU    sp, sp, ABI_STACK(11*ABI_GPR+6*ABI_FPR+8)
#endif
#ifdef SUPPORT_OVR
	ABI_PADDIU sp, sp, -ABI_STACK(2*ABI_GPR)
	sd a5, 0*ABI_GPR(sp)
	sd ra, 1*ABI_GPR(sp)
	ABI_PLA v1, ovrtimer_start
	jalr v1					/* Х󥿥ޤư */
	ld a5, 0*ABI_GPR(sp)
	ld ra, 1*ABI_GPR(sp)
	ABI_PADDIU sp, sp, ABI_STACK(2*ABI_GPR)
#endif /* SUPPORT_OVR */

	/* 㳰׵Υå */
	lb t4, TCB_svclevel(a5) /* t4 = p_runtsk->svclevel */
	bne t4, zero, dispatch_r_1 /* branch if p_runtsk->svclevel != 0 */

	lb      a6, TCB_enatex(a5)
	andi    t4, a6, TCB_enatex_mask	/* t4 = p_runtsk->enatex */
	beq     t4, zero, dispatch_r_1	/* 㳰ػߤλ */

	lw      t5, TCB_texptn(a5)	/* t5 = p_runtsk->texptn */
	beq     t5, zero, dispatch_r_1	/* 㳰׵᤬̵ */

	ABI_PLA v1, call_texrtn_smode
	jr       v1		/* 㳰롼(å
					   ¸)θƤӽФ */
		/* call_texrtn_smode()(task.c)ǤϡºݤΥ㳰롼Ƥ
		   Фǡunlock_cpulock_cpuԤäƤΤǡ֤
		   ݻ롣 */

dispatch_r_1:
	jr      ra			/* dispatch ƤӽФ */

/* ͥ뵯ưΤᡤnontask_nest = 1 */
	.global start_dispatch
start_dispatch:
	ABI_PLA t8, nontask_nest
	sd zero, (t8)		/* ͥȥ󥿤򥯥ꥢ */

/* ߼¹ΥƥȤΤƤơǥѥåƤӽФ */
exit_and_dispatch:

dispatcher:
	/* ˤ CPUåʳ߶ػߡˤ뤳 */
	ABI_PLA      a4, p_schedtsk
	ABI_PL      a5, (a4)		/* a5 = p_schedtsk */
	beq     a5, zero, dispatcher_2	/* p_schedtsk ̵гԤ */

dispatcher_1:
	ABI_PLA      a4, p_runtsk
	ABI_PS      a5, (a4)		/* p_runtsk = a5 (= p_schedtsk)
					   (åμ¹) */
	ABI_PL      a6, TCB_pc(a5)		/* ¹ԺƳϤ롣
					   ¹ԺƳϤϰʲ3̤
					     ǥѥåνи  dispatch_r
					     ߡ㳰νи    ret_int_r
					     ưľ        activate_r
					   ξ a5=p_runtsk ȤƸƤ
					   ФƤ뤳Ȥա */
	ABI_PL      sp, TCB_sp(a5)		/* åݥ󥿤 */
	jr      a6			/* ¹ԺƳϤإ */

	/*
	 *  ¹Ԥ٤ޤԤĽ
	 *
	 *  ǥƥȤڤ괹Τϡ
	 *    ȯ߽ˤɤΥåȤȤβ
	 *    ߥϥɥǤΥǥѥåɻ
	 *  ȤĤΰ̣롥
	 */ 
dispatcher_2:
	ABI_PLA	a6, p_runtsk
	ABI_PS	zero, (a6)		/* p_runtsk = NULL
					   ϡiget_id TSK_NONE֤
					   б뤿ᡣ*/

	ABI_PLA t8, istk
	ABI_PL t8, (t8)
	ABI_PLA t9, istksz
	ABI_PL t9, (t9)
	ABI_PADDU sp, t8, t9		/* åڤؤ */
	ABI_PLA t8, nontask_nest
	li t9, 1
	sd t9, (t8)			/* ͥȥ󥿡1 */

	/* 롼ǻȤν */
	ABI_PLA      a6, reqflg              /* reqflg Υɥ쥹 */
	li      t4, ~SR_IE              /* Status γߵĥӥå */

dispatcher_3:
	mfc0    a5, Status
	ori     a5, a5, SR_IE		/* IEӥåȥå */
	mtc0    a5, Status		/* ߵ : unlock_cpu  */
	CLEAR_HAZARD_STATUS_INTERRUPT_ENABLE
	and     a5, a5, t4		/* IEӥåȥꥻå */
	mtc0    a5, Status		/* ߶ػ : lock_cpu  */

	CLEAR_HAZARD_STATUS_INTERRUPT_DISABLE		/* CP0ϥɤΤλֲԤޥ
					   (Υޥϥƥ¸) */

	lw      t5, (a6)		/* t5 = reqflg */

	beq     t5, zero, dispatcher_3	/* ǥѥå׵᤬ʤХ롼פ
					   Ƭ */
	sw      zero, (a6)		/* reqflg = NULL (reqflg򥯥ꥢ) */
	ABI_PLA t8, nontask_nest
	sd zero, (t8)		/* ͥȥ󥿤򥯥ꥢ */
	b       dispatcher		/* ¹ԺƳϤμإ */

/*
 *  ͥνλθƽФ
 */
	.global call_exit_kernel
call_exit_kernel:
	ABI_PLA t8, istk
	ABI_PL t8, (t8)
	ABI_PLA t9, istksz
	ABI_PL t9, (t9)
	ABI_PADDU sp, t8, t9
	ABI_PLA t8, nontask_nest
	li t9, 1
	sd t9, (t8)
	ABI_PLA v1, exit_kernel
	jr v1

/*
 *  ߥϥɥ/CPU㳰ϥɥи
 *
 *  褬ƥȤreqflgåȤƤΤߡˤ롣
 *  nontask_nest = 0߶ػ߾֡ѥ쥸¸֤ǸƤӽФȡ
 *  a5p_runtskͤƤret_int_1˥פ뤳ȡ
 */

ret_int:
	ABI_PLA      a4, dspflg
	ABI_PLA      a7, p_runtsk
	lw      a6, (a4)		/* a6 = dspflg */
	ABI_PL      a5, (a7)		/* a5 = p_runtsk */
 	beq     a6, zero, ret_int_1	/* ǥѥåػߤʤ饸 */
	ABI_PLA      t4, p_schedtsk
	ABI_PL      t5, (t4)		/* t5 = p_schedtsk */
	beq     a5, t5, ret_int_1	/* p_runtsk = p_schedtsk ʤ饸 */

/* ǥѥåͳν (a5 = p_runtsk ) */
#if ABI_FPR == 0
	ABI_PADDIU    sp, sp, -ABI_STACK(10*ABI_GPR+4)		/* å쥸¸ */
#else /* ABI_FPR == 8 */
	ABI_PADDIU    sp, sp, -ABI_STACK(10*ABI_GPR+6*ABI_FPR+8)		/* å쥸¸ */
#endif
	sd      s0, 0*ABI_GPR(sp)
	sd      s1, 1*ABI_GPR(sp)
	sd      s2, 2*ABI_GPR(sp)
	sd      s3, 3*ABI_GPR(sp)
	sd      s4, 4*ABI_GPR(sp)
	sd      s5, 5*ABI_GPR(sp)
	sd      s6, 6*ABI_GPR(sp)
	sd      s7, 7*ABI_GPR(sp)
	sd gp, 8*ABI_GPR(sp)
	sd s8, 9*ABI_GPR(sp)

#if ABI_FPR == 0
#else /* ABI_FPR == 8 */
	sdc1 $f20, 10*ABI_GPR+0*ABI_FPR(sp)
	sdc1 $f22, 10*ABI_GPR+1*ABI_FPR(sp)
	sdc1 $f24, 10*ABI_GPR+2*ABI_FPR(sp)
	sdc1 $f26, 10*ABI_GPR+3*ABI_FPR(sp)
	sdc1 $f28, 10*ABI_GPR+4*ABI_FPR(sp)
	sdc1 $f30, 10*ABI_GPR+5*ABI_FPR(sp)
	cfc1 t4, $31
	sw t4, 10*ABI_GPR+6*ABI_FPR(sp)
#endif

	ABI_PLA t4, rundom
	lw t5, (t4)
#if ABI_FPR == 0
	sw t5, 10*ABI_GPR(sp)
#else /* ABI_FPR == 8 */
	sw t5, 10*ABI_GPR+6*ABI_FPR+4(sp)
#endif
					/* a5 = p_runtsk   */
	ABI_PS      sp, TCB_sp(a5)		/* p_runtsk->sp = sp
					   (åݥ󥿤¸) */
	ABI_PLA      a6, ret_int_r

	ABI_PS      a6, TCB_pc(a5)		/* p_runtsk->pc = ret_int_r
					   (¹ԺƳϤ¸) */
	b       dispatcher		/* ǥѥåƤӽФ */

/*
 * ߡ㳰νи
 *   ǥѥåˤơa5 = p_runtsk ȤʤäƤ뤳Ȥ
 *   åݥ󥿤Ѥ
 */
/* ǥѥåƤӽФΥƥȤιή */
ret_int_r:
	ld      s0, 0*ABI_GPR(sp)		/* å쥸 */
	ld      s1, 1*ABI_GPR(sp)
	ld      s2, 2*ABI_GPR(sp)
	ld      s3, 3*ABI_GPR(sp)
 	ld      s4, 4*ABI_GPR(sp)
	ld      s5, 5*ABI_GPR(sp)
	ld      s6, 6*ABI_GPR(sp)
	ld      s7, 7*ABI_GPR(sp)
	ld gp, 8*ABI_GPR(sp)
	ld s8, 9*ABI_GPR(sp)

#if ABI_FPR == 0
#else /* ABI_FPR == 8 */
	ldc1 $f20, 10*ABI_GPR+0*ABI_FPR(sp)
	ldc1 $f22, 10*ABI_GPR+1*ABI_FPR(sp)
	ldc1 $f24, 10*ABI_GPR+2*ABI_FPR(sp)
	ldc1 $f26, 10*ABI_GPR+3*ABI_FPR(sp)
	ldc1 $f28, 10*ABI_GPR+4*ABI_FPR(sp)
	ldc1 $f30, 10*ABI_GPR+5*ABI_FPR(sp)
	lw t4, 10*ABI_GPR+6*ABI_FPR(sp)
	ctc1 t4, $31
#endif

	ABI_PLA t4, rundom
#if ABI_FPR == 0
	lw t5, 10*ABI_GPR(sp)
#else /* ABI_FPR == 8 */
	lw t5, 10*ABI_GPR+6*ABI_FPR+4(sp)
#endif
	sw t5, (t4)
#if ABI_FPR == 0
	ABI_PADDIU    sp, sp, ABI_STACK(10*ABI_GPR+4)
#else /* ABI_FPR == 8 */
	ABI_PADDIU    sp, sp, ABI_STACK(10*ABI_GPR+6*ABI_FPR+8)
#endif

/* ǥѥåͳʤιή (a5 = p_runtsk ) */
ret_int_1:
#ifdef SUPPORT_OVR
	ABI_PADDIU sp, sp, -ABI_STACK(1*ABI_GPR)
	sd a5, 0*ABI_GPR(sp)
	ABI_PLA v1, ovrtimer_start
	jalr v1					/* Х󥿥ޤư */
	ld a5, 0*ABI_GPR(sp)
	ABI_PADDIU sp, sp, ABI_STACK(1*ABI_GPR)
#endif /* SUPPORT_OVR */
ret_int_2:
#if ABI_FPR == 0
	lw a4, 22*ABI_GPR(sp) /* Status */
#else /* ABI_FPR == 8 */
	lw a4, 22*ABI_GPR+26*ABI_FPR(sp) /* Status */
#endif
	mtc0 a4, Status /* EXL = 1 */

	/* 㳰׵Υå */
	andi t4, a4, SR_IE
	beq t4, zero, ret_int_3 /* branch if Status.IE == 0 */

	lb t4, TCB_svclevel(a5) /* t4 = p_runtsk->svclevel */
	bne t4, zero, ret_int_3 /* branch if p_runtsk->svclevel != 0 */

	lb      a6, TCB_enatex(a5)
	andi    t4, a6, TCB_enatex_mask /* t4 = p_runtsk->enatex  */
	beq     t4, zero, ret_int_3     /* 㳰ػߤλ */

	lw      t5, TCB_texptn(a5)      /* t5 = p_runtsk->texptn */
	beq     t5, zero, ret_int_3	/* 㳰׵᤬̵ */

	andi t4, a4, SR_KSU
	bne t4, zero, ret_int_6 /* branch if Status.KSU != 0 */

	ori	a4, a4, (SR_EXL | SR_IE)
	xori	a4, a4, (SR_EXL | SR_IE)	/* lock_cpu (߶ػ)
					    + EXLӥåȥꥢ (ߵ) */
	mtc0	a4, Status

	ABI_PLA v1, call_texrtn_smode
	jalr     v1             /* 㳰롼(å
					   ¸)θƤӽФ */
		/* call_texrtn_smode()(task.c)ǤϡºݤΥ㳰롼Ƥ
		   Фǡunlock_cpulock_cpuԤäƤΤǡ֤
		   ݻ롣 */

	mfc0	a4, Status
	ori	a4, a4, (SR_EXL | SR_IE)	/* unlock_cpu  (ߵ)
					    + EXLӥåȥå (߶ػ) */
	mtc0	a4, Status

ret_int_3:
	mfc0 t4, Status
	andi t4, t4, SR_KSU
	beq t4, zero, ret_int_4 /* branch if Status.KSU == 0 */
	ABI_PLA v1, tlb_umode
	jalr v1
ret_int_4:
	/* 쥸 (Status쥸ϡѤ) */

#if ABI_FPR == 0
#else /* ABI_FPR == 8 */
	ldc1 $f0, 22*ABI_GPR+0*ABI_FPR(sp)
	ldc1 $f1, 22*ABI_GPR+1*ABI_FPR(sp)
	ldc1 $f2, 22*ABI_GPR+2*ABI_FPR(sp)
	ldc1 $f3, 22*ABI_GPR+3*ABI_FPR(sp)
	ldc1 $f4, 22*ABI_GPR+4*ABI_FPR(sp)
	ldc1 $f5, 22*ABI_GPR+5*ABI_FPR(sp)
	ldc1 $f6, 22*ABI_GPR+6*ABI_FPR(sp)
	ldc1 $f7, 22*ABI_GPR+7*ABI_FPR(sp)
	ldc1 $f8, 22*ABI_GPR+8*ABI_FPR(sp)
	ldc1 $f9, 22*ABI_GPR+9*ABI_FPR(sp)
	ldc1 $f10, 22*ABI_GPR+10*ABI_FPR(sp)
	ldc1 $f11, 22*ABI_GPR+11*ABI_FPR(sp)
	ldc1 $f12, 22*ABI_GPR+12*ABI_FPR(sp)
	ldc1 $f13, 22*ABI_GPR+13*ABI_FPR(sp)
	ldc1 $f14, 22*ABI_GPR+14*ABI_FPR(sp)
	ldc1 $f15, 22*ABI_GPR+15*ABI_FPR(sp)
	ldc1 $f16, 22*ABI_GPR+16*ABI_FPR(sp)
	ldc1 $f17, 22*ABI_GPR+17*ABI_FPR(sp)
	ldc1 $f18, 22*ABI_GPR+18*ABI_FPR(sp)
	ldc1 $f19, 22*ABI_GPR+19*ABI_FPR(sp)
	ldc1 $f21, 22*ABI_GPR+20*ABI_FPR(sp)
	ldc1 $f23, 22*ABI_GPR+21*ABI_FPR(sp)
	ldc1 $f25, 22*ABI_GPR+22*ABI_FPR(sp)
	ldc1 $f27, 22*ABI_GPR+23*ABI_FPR(sp)
	ldc1 $f29, 22*ABI_GPR+24*ABI_FPR(sp)
	ldc1 $f31, 22*ABI_GPR+25*ABI_FPR(sp)
#endif

	ld      a5, 21*ABI_GPR(sp)		/* EPC */
	dmtc0    a5, EPC

	ld      a6, 19*ABI_GPR(sp)		/* HI */
	ld      a7, 20*ABI_GPR(sp)		/* LO */

	mthi    a6			/* 쥸 HI  */
	mtlo    a7			/* 쥸 LO  */

	.set noat
	ld      $at,  0*ABI_GPR(sp)
	ld      v0,  1*ABI_GPR(sp)
	ld      v1,  2*ABI_GPR(sp)
	ld      a0,  3*ABI_GPR(sp)
	ld      a1,  4*ABI_GPR(sp)
	ld      a2,  5*ABI_GPR(sp)
	ld      a3,  6*ABI_GPR(sp)
	ld      a4,  7*ABI_GPR(sp)
	ld      a5,  8*ABI_GPR(sp)
	ld      a6,  9*ABI_GPR(sp)
	ld      a7, 10*ABI_GPR(sp)
	ld      t4, 11*ABI_GPR(sp)
	ld      t5, 12*ABI_GPR(sp)
	ld      t6, 13*ABI_GPR(sp)
	ld      t7, 14*ABI_GPR(sp)
	ld      t8, 15*ABI_GPR(sp)
	ld      t9, 16*ABI_GPR(sp)

	ld      gp, 17*ABI_GPR(sp)
	ld      ra, 18*ABI_GPR(sp)

#if ABI_FPR == 0
	ABI_PADDIU    sp, sp, ABI_STACK(22*ABI_GPR+8)
#else /* ABI_FPR == 8 */
	ABI_PADDIU    sp, sp, ABI_STACK(22*ABI_GPR+26*ABI_FPR+8)
#endif

	mfc0 kt1, Status
	andi kt1, kt1, SR_KSU
	beq kt1, zero, ret_int_5 /* branch if Status.KSU == 0 */
	ABI_PLA kt1, p_runtsk
	ABI_PL kt1, (kt1)
	ABI_PL sp, TCB_usp(kt1) /* sp = p_runtsk->usp */
	ABI_PLA kt1, rundom
	lw kt1, (kt1)
	clz kt1, kt1
	dmtc0 kt1, EntryHi
ret_int_5:
	eret				/* /㳰 */
	.set at

ret_int_6:
	ori a4, a4, (SR_KSU | SR_EXL | SR_IE)
	xori a4, a4, (SR_KSU | SR_EXL | SR_IE)
	mtc0 a4, Status /* KSU = 0, EXL = 0, IE = 0 */
	move a0, sp
#if ABI_FPR == 0
	li a1, ABI_STACK(22*ABI_GPR+8-8)
#else /* ABI_FPR == 8 */
	li a1, ABI_STACK(22*ABI_GPR+26*ABI_FPR+8-8)
#endif
	ABI_PLA v1, prepare_texrtn_umode
	jalr v1
	bne v0, zero, ret_int_7
#if ABI_FPR == 0
	lw a4, 22*ABI_GPR(sp) /* Status */
#else /* ABI_FPR == 8 */
	lw a4, 22*ABI_GPR+26*ABI_FPR(sp) /* Status */
#endif
	mtc0 a4, Status /* KSU = 2, EXL = 1, IE = 1 */
	b ret_int_3

ret_int_7:
	li t6, (EXCNO_CALTEX_ILLSTK << 2)
	ABI_PLA v1, call_illegal_texstk
	jalr v1
#if ABI_FPR == 0
	lw a4, 22*ABI_GPR(sp) /* Status */
#else /* ABI_FPR == 8 */
	lw a4, 22*ABI_GPR+26*ABI_FPR(sp) /* Status */
#endif
	mtc0 a4, Status /* KSU = 2, EXL = 1, IE = 1 */
	b ret_int_3

/*
 *  ̤ݡȤΥӥΥȥ
 */
no_support:
	li v0, E_RSFN
	jr ra

/*
 *  ӥ륨ȥơ֥
 */
#define FNTYPE .word
#define LABEL(a) a
#define RET_TEX ret_tex
svc_table:
#include "svc_table.S"
	FNTYPE no_support

/*
 *  ӥʬ
 */
exccode_sys:
	ld t5, 21*ABI_GPR(sp) /* EPC */
	ABI_PADDIU t5, t5, 4
	sd t5, 21*ABI_GPR(sp) /* EPC */

	blez v0, exccode_sys_0
	ABI_PLA v1, extsvc_entry
	move a5, v0
	b exccode_sys_2
exccode_sys_0:
	addiu v0, v0, -TMIN_FNCD
	bgez v0, exccode_sys_1
	ABI_PLA v1, no_support
	b exccode_sys_2
exccode_sys_1:
	ABI_PLA t5, svc_table
	sll v0, v0, 2
	ABI_PADDU t5, t5, v0
	ABI_PL v1, (t5)

exccode_sys_2:
	ABI_PLA t8, nontask_nest
	ld t9, (t8)
	bne t9, zero, exccode_sys_3
	ABI_PLA t5, p_runtsk
	ABI_PL t5, (t5)
	lb t6, TCB_svclevel(t5) /* t6 = p_runtsk->svclevel */
	addiu t6, t6, 1
	sb t6, TCB_svclevel(t5) /* p_runtsk->svclevel += 1 */
	bne t6, zero, exccode_sys_3 /* branch if p_runtsk->svclevel != 0 */
	li v0, E_SYS
	b exccode_sys_4

exccode_sys_3:
	ori t4, t4, (SR_KSU | SR_EXL)
	xori t4, t4, (SR_KSU | SR_EXL)
	mtc0 t4, Status /* KSU = 0, EXL = 0 */
	jalr v1
	mfc0 t4, Status
	ori t4, t4, SR_EXL
	mtc0 t4, Status /* KSU = 0, EXL = 1 */
	CLEAR_HAZARD_STATUS_INTERRUPT_DISABLE

	andi t4, t4, (SR_IM | SR_IE)
#if ABI_FPR == 0
	lw t5, 22*ABI_GPR(sp) /* Status */
#else /* ABI_FPR == 8 */
	lw t5, 22*ABI_GPR+26*ABI_FPR(sp) /* Status */
#endif
	ori t5, t5, (SR_IM | SR_IE)
	xori t5, t5, (SR_IM | SR_IE)
	or t5, t5, t4
#if ABI_FPR == 0
	sw t5, 22*ABI_GPR(sp) /* Status */
#else /* ABI_FPR == 8 */
	sw t5, 22*ABI_GPR+26*ABI_FPR(sp) /* Status */
#endif

exccode_sys_4:
	sd v0, 1*ABI_GPR(sp) /* v0 */

	ABI_PLA t8, nontask_nest
	ld t9, (t8)
	bne t9, zero, ret_to_task_int
	ABI_PLA a5, p_runtsk
	ABI_PL a5, (a5) /* a5 = p_runtsk */
	lb t4, TCB_svclevel(a5) /* t4 = p_runtsk->svclevel */
	addiu t4, t4, -1
	sb t4, TCB_svclevel(a5) /* p_runtsk->svclevel -= 1 */
	bne t4, zero, ret_int_2 /* branch if p_runtsk->svclevel != 0 */
	lb t4, TCB_waifbd(a5)
	li t5, ~TCB_waifbd_mask
	and t4, t4, t5
	sb t4, TCB_waifbd(a5) /* p_runtsk->waifbd = 0 */
	b ret_int_2

/*
 *  㳰롼󤫤Υ꥿
 */
ret_tex:
#if ABI_FPR == 0
	lw t4, 22*ABI_GPR(sp) /* Status */
#else /* ABI_FPR == 8 */
	lw t4, 22*ABI_GPR+26*ABI_FPR(sp) /* Status */
#endif
	andi t5, t4, SR_KSU
	bne t5, zero, ret_tex_0
	li v0, E_CTX
	jr ra

ret_tex_0:
	ori t4, t4, (SR_KSU | SR_EXL | SR_IE)
	xori t4, t4, (SR_KSU | SR_EXL | SR_IE)
	mtc0 t4, Status /* KSU = 0, EXL = 0, IE = 0 */
	CLEAR_HAZARD_STATUS_INTERRUPT_DISABLE
	move a0, sp
#if ABI_FPR == 0
	li a1, ABI_STACK(22*ABI_GPR+8-8)
#else /* ABI_FPR == 8 */
	li a1, ABI_STACK(22*ABI_GPR+26*ABI_FPR+8-8)
#endif
	ABI_PADDIU sp, sp, -ABI_STACK(1*ABI_GPR)
	sd ra, 0*ABI_GPR(sp)
	ABI_PLA v1, prepare_ret_tex_umode
	jalr v1
	ld ra, 0*ABI_GPR(sp)
	ABI_PADDIU sp, sp, ABI_STACK(1*ABI_GPR)
	bne v0, zero, ret_tex_1
	mfc0 t4, Status
	ori t4, t4, (SR_EXL | SR_IE)
	mtc0 t4, Status /* KSU = 0, EXL = 1, IE = 1 */
	ld v0, 1*ABI_GPR(sp) /* v0 */
	jr ra

ret_tex_1:
	li t6, (EXCNO_RETTEX_ILLSTK << 2)
	ABI_PADDIU sp, sp, -ABI_STACK(1*ABI_GPR)
	sd ra, 0*ABI_GPR(sp)
	ABI_PLA v1, call_illegal_texstk
	jalr v1
	ld ra, 0*ABI_GPR(sp)
	ABI_PADDIU sp, sp, ABI_STACK(1*ABI_GPR)
#if ABI_FPR == 0
	lw t4, 22*ABI_GPR(sp) /* Status */
#else /* ABI_FPR == 8 */
	lw t4, 22*ABI_GPR+26*ABI_FPR(sp) /* Status */
#endif
	ori t4, t4, SR_KSU
	xori t4, t4, SR_KSU
	mtc0 t4, Status /* KSU = 0, EXL = 1 */
	li v0, E_MACV
	jr ra

/*
 *  㳰å㳰ϥɥθƽФ
 */
call_illegal_texstk:
#if ABI_FPR == 0
	ABI_PADDIU sp, sp, -ABI_STACK(22*ABI_GPR+8)
#else /* ABI_FPR == 8 */
	ABI_PADDIU sp, sp, -ABI_STACK(22*ABI_GPR+26*ABI_FPR+8)
#endif
	sd zero, 0*ABI_GPR(sp) /* at */
	sd t4, 11*ABI_GPR(sp)
	sd t5, 12*ABI_GPR(sp)
	sd t6, 13*ABI_GPR(sp)
	mfc0 t4, Status
	ori t4, t4, (SR_EXL | SR_IE)
	mfc0 t5, Cause
	ABI_PLA t7, call_illegal_texstk_0
	dmtc0 t7, EPC
	b general_exception_1

call_illegal_texstk_0:
	mfc0 t4, Status
	ori t4, t4, SR_IE
	xori t4, t4, SR_IE
	mtc0 t4, Status /*  KSU = 0, EXL = 0, IE = 0 */
	CLEAR_HAZARD_STATUS_INTERRUPT_DISABLE
	jr ra

/*
 *  Ԥ
 */
	.global sil_dly_nse
sil_dly_nse:
	li t4, SIL_DLY_TIM1
	sltu t5, t4, a0
	subu a0, a0, t4
	beq t5, zero, sil_dly_nse_2 /* t4(SIL_DLY_TIM1) >= a0 ʤ꥿ */
	li t4, SIL_DLY_TIM2
sil_dly_nse_1:
	sltu t5, t4, a0
	subu a0, a0, t4
	bne t5, zero, sil_dly_nse_1 /* t4(SIL_DLY_TIM2) < a0 ʤ롼 */
sil_dly_nse_2:
	jr ra

/*
 *  㳰/߽롼ʰ㳰
 *
 *  ͡
 *  CPU㳰ϥɥϡ󥿥ƥȤǼ¹Ԥ롣
 *  nontask_nest 򡢳ߡ㳰ͥȥ󥿤ȤƻѤ롣
 *  reqflg å˳ߤػߤʤȡreqflg å˵ư
 *    줿ߥϥɥǥǥѥå׵ᤵ줿˥ǥѥåʤ
 *  ߵġԵĤνϡEXLӥåȤѤƹԤ
 *    ϡƽиΥƥȤ CPUå֤¸뤿Ǥ롣
 *    ˽ܹԤˤIEӥåȤѤơߵġԵ
 *    ¸ɬפ뤿ˡIEӥåȤˤߵġԵĤѹƤ
 *    ա
 *    㡧ٱǥѥåνľ㳰ƽФľ
 */

	.global general_exception
	.global join_interrupt_and_exception
		/* ؿƽ(proc_interrupt_sys)ɬ */

general_exception:
	.set noat
	dmtc0 zero, EntryHi /* ASID = 0 */
	mfc0 kt1, Status
	andi kt1, kt1, SR_KSU
	beq kt1, zero, general_exception_0 /* branch if Status.KSU == 0 */
	ABI_PLA kt1, p_runtsk
	ABI_PL kt1, (kt1)
	ABI_PS sp, TCB_usp(kt1) /* p_runtsk->usp = sp */
	ABI_PL kt1, TCB_p_tinib(kt1)
	ABI_PL sp, TINIB_sstk(kt1) /* sp = p_runtsk->p_tinib->sstk */
	ABI_PL kt1, TINIB_sstksz(kt1)
	ABI_PADDU sp, sp, kt1 /* sp += p_runtsk->p_tinib->sstksz */
general_exception_0:
#if ABI_FPR == 0
	ABI_PADDIU    sp, sp, -ABI_STACK(22*ABI_GPR+8)
#else /* ABI_FPR == 8 */
	ABI_PADDIU    sp, sp, -ABI_STACK(22*ABI_GPR+26*ABI_FPR+8)
#endif
	sd      $at,  0*ABI_GPR(sp)		/* EXCSTACK¤(default_exc_handlerؿ) */
	.set at
	sd      t4, 11*ABI_GPR(sp)
	sd      t5, 12*ABI_GPR(sp)
	sd      t6, 13*ABI_GPR(sp)

	mfc0    t4, Status		/* t4 -> 㳰ǻȤ */
	li t5, ~SR_TS
	and t4, t4, t5 /* Status.TS = 0 */
	mfc0 t5, Cause
	andi t6, t5, ExcCode_mask /* t6 = Cause.ExcCode << 2 */

general_exception_1:
	sd      v0,  1*ABI_GPR(sp)
	sd      v1,  2*ABI_GPR(sp)
	sd      a0,  3*ABI_GPR(sp)
	sd      a1,  4*ABI_GPR(sp)
	sd      a2,  5*ABI_GPR(sp)
	sd      a3,  6*ABI_GPR(sp)
	sd      a4,  7*ABI_GPR(sp)
	sd      a5,  8*ABI_GPR(sp)
	sd      a6,  9*ABI_GPR(sp)
	sd      a7, 10*ABI_GPR(sp)
	sd      t7, 14*ABI_GPR(sp)
	sd      t8, 15*ABI_GPR(sp)
	sd      t9, 16*ABI_GPR(sp)
	sd      gp, 17*ABI_GPR(sp)
	sd      ra, 18*ABI_GPR(sp)

	mfhi    a6			/* 쥸 HI  */
	mflo    a7			/* 쥸 LO  */

	sd      a6, 19*ABI_GPR(sp)		/* HI */
	sd      a7, 20*ABI_GPR(sp)		/* LO */

	dmfc0    a5, EPC
	sd      a5, 21*ABI_GPR(sp)		/* EPC */

#if ABI_FPR == 0
#else /* ABI_FPR == 8 */
	sdc1 $f0, 22*ABI_GPR+0*ABI_FPR(sp)
	sdc1 $f1, 22*ABI_GPR+1*ABI_FPR(sp)
	sdc1 $f2, 22*ABI_GPR+2*ABI_FPR(sp)
	sdc1 $f3, 22*ABI_GPR+3*ABI_FPR(sp)
	sdc1 $f4, 22*ABI_GPR+4*ABI_FPR(sp)
	sdc1 $f5, 22*ABI_GPR+5*ABI_FPR(sp)
	sdc1 $f6, 22*ABI_GPR+6*ABI_FPR(sp)
	sdc1 $f7, 22*ABI_GPR+7*ABI_FPR(sp)
	sdc1 $f8, 22*ABI_GPR+8*ABI_FPR(sp)
	sdc1 $f9, 22*ABI_GPR+9*ABI_FPR(sp)
	sdc1 $f10, 22*ABI_GPR+10*ABI_FPR(sp)
	sdc1 $f11, 22*ABI_GPR+11*ABI_FPR(sp)
	sdc1 $f12, 22*ABI_GPR+12*ABI_FPR(sp)
	sdc1 $f13, 22*ABI_GPR+13*ABI_FPR(sp)
	sdc1 $f14, 22*ABI_GPR+14*ABI_FPR(sp)
	sdc1 $f15, 22*ABI_GPR+15*ABI_FPR(sp)
	sdc1 $f16, 22*ABI_GPR+16*ABI_FPR(sp)
	sdc1 $f17, 22*ABI_GPR+17*ABI_FPR(sp)
	sdc1 $f18, 22*ABI_GPR+18*ABI_FPR(sp)
	sdc1 $f19, 22*ABI_GPR+19*ABI_FPR(sp)
	sdc1 $f21, 22*ABI_GPR+20*ABI_FPR(sp)
	sdc1 $f23, 22*ABI_GPR+21*ABI_FPR(sp)
	sdc1 $f25, 22*ABI_GPR+22*ABI_FPR(sp)
	sdc1 $f27, 22*ABI_GPR+23*ABI_FPR(sp)
	sdc1 $f29, 22*ABI_GPR+24*ABI_FPR(sp)
	sdc1 $f31, 22*ABI_GPR+25*ABI_FPR(sp)
#endif

#if ABI_FPR == 0
	sw      t4, 22*ABI_GPR(sp)		/* Status */
	sw t5, 22*ABI_GPR+4(sp) /* Cause */
#else /* ABI_FPR == 8 */
	sw      t4, 22*ABI_GPR+26*ABI_FPR(sp)		/* Status */
	sw t5, 22*ABI_GPR+26*ABI_FPR+4(sp) /* Cause */
#endif

	/* gp (Хݥ)
	     _gp ϡƥ¸(󥫥ץȿ侩) */
	ABI_PLA	gp, _gp

	ori t7, t4, (SR_KSU | SR_EXL | SR_IE)
	xori t7, t7, (SR_KSU | SR_EXL | SR_IE)
	mtc0 t7, Status /* KSU = 0, EXL = 0, IE = 0  */

	li t7, (Sys << 2)
	beq t6, t7, exccode_sys

	move	a0, sp			/* 㳰ϥɥΰ */
		/* ϡ㳰ȯΥǡ򤷤åΰؤΥݥ
		   ߥȥΥǡޤʣˤʤ뤿ᡢ
		   оݤMIPS32Υ쥸ʬΤߤȤ롣 */

	ABI_PLA t8, nontask_nest
	ld t7, (t8)
	daddiu t9, t7, 1
	sd t9, (t8)               /* ͥȥ󥿤Υ󥯥 */
	bne    t7, zero, multipul_exception  /*  ʤ㳰¿㳰Ƚ */

/* ʤ㳰ξ */
first_exception:
	ABI_PLA t8, istk
	ABI_PL t8, (t8)
	ABI_PLA t9, istksz
	ABI_PL t9, (t9)
	ABI_PADDU a7, t8, t9
	ABI_PADDIU a7, a7, -ABI_STACK(1*ABI_GPR)
	sd      sp, (a7)		/* åݥ󥿤¸ */
	move    sp, a7			/* åڤؤ */
#ifdef SUPPORT_OVR
	ABI_PADDIU sp, sp, -ABI_STACK(4*ABI_GPR)
	sd a0, 0*ABI_GPR(sp)
	sd t4, 1*ABI_GPR(sp)
	sd t5, 2*ABI_GPR(sp)
	sd t6, 3*ABI_GPR(sp)
	ABI_PLA v1, ovrtimer_stop
	jalr v1					/* Х󥿥ޤ */
	ld a0, 0*ABI_GPR(sp)
	ld t4, 1*ABI_GPR(sp)
	ld t5, 2*ABI_GPR(sp)
	ld t6, 3*ABI_GPR(sp)
	ABI_PADDIU sp, sp, ABI_STACK(4*ABI_GPR)
#endif /* SUPPORT_OVR */

	ABI_PLA v1, proc_interrupt_and_exception
	jalr     v1	/* ߤ㳰Ƚ̽ */

	/*  ߶ػߤäƤ  */
	ABI_PLA      a6, reqflg
	lw      a7, (a6)		/* a7 = reqflg */
	ld      sp, (sp)		/* åڤؤ */
#ifdef SUPPORT_OVR
	beq     a7, zero, first_exception_0	/* ǥѥå׵᤬ʤ */
#else
	beq     a7, zero, ret_to_task_int	/* ǥѥå׵᤬ʤ */
#endif /* SUPPORT_OVR */

	sw      zero, (a6)		/* reqflg Υꥢ */
	b       ret_int			/* ߡ㳰νи */

#ifdef SUPPORT_OVR
first_exception_0:
	ABI_PLA v1, ovrtimer_start
	jalr v1					/* Х󥿥ޤư */
	b ret_to_task_int
#endif /* SUPPORT_OVR */

/* ¿㳰¿ųߡˤξ (㳰ϥɥΰϴ a0 Ѥ) */
multipul_exception:
	ABI_PLA v1, proc_interrupt_and_exception
	jalr     v1	/* ߤ㳰Ƚ̽ */

/* ǥѥåƤФñ˳߸㳰ȯˤ */
ret_to_task_int:
#if ABI_FPR == 0
	lw      a4, 22*ABI_GPR(sp)    	/* Status */
#else /* ABI_FPR == 8 */
	lw      a4, 22*ABI_GPR+26*ABI_FPR(sp)    	/* Status */
#endif
	/*
	 *  ¿㳰ʤΤǡåʤʤΤǡƥ
	 *  γߥޥѹƤ뿴ۤϤʤ
	 *  ʥơ쥸ϸͤ򤽤Τޤ޽᤹
	 */
	mtc0    a4, Status
	b ret_int_3

/*
 *  ߤ㳰Ƚ̽ؿ
 *    ʲΥ쥸ͤѤ
 *      a0 : 㳰ϥɥΰ, t4 : ơ쥸
 */
proc_interrupt_and_exception:
	ABI_PADDIU    sp, sp, -ABI_STACK(1*ABI_GPR)
	sd      ra, 0(sp)

	beq     t6, zero, proc_interrupt        /* ߤ㳰Ƚ */
		/* ľproc_interrupt_sysӤϤʤ
		   ǽΤǡproc_interrupt֡ */

/* ߰ʳ㳰ν */
	ABI_PLA      t7, exc_table
         	              		/* t4 = Status  */
	ori     t5, t4, (SR_KSU | SR_EXL)
	xori    t5, t5, (SR_KSU | SR_EXL)		/* EXLӥåȥꥢ */
		/* ߰ʳ㳰CPUå֤ǤդΤǡCPUå
		   ֤¸ɬפ롣ΤIEӥåȤˡ
		   ߶ػߡĤEXLӥåȤѤƼ¸ */
#if ABI_POINTER == 4
#else /* ABI_POINTER == 8 */
	sll t6, t6, 1
#endif
	ABI_PADDU     t6, t7, t6		/* 㳰бɥ쥹 */
	ABI_PL      t7, (t6)		/* C롼θƽХɥ쥹 */
	mtc0    t5, Status		/* ߵ (EXLӥå = 0) */
	jalr    t7			/* C롼ƤӽФ */

	mfc0    a4, Status
	ori     a4, a4, SR_IE
	xori a4, a4, SR_IE
	mtc0    a4, Status              /* ߶ػ (IEӥå = 0) */

	CLEAR_HAZARD_STATUS_INTERRUPT_DISABLE		/* CP0ϥɤΤλֲԤޥ
					   (Υޥϥƥ¸) */

	b       join_interrupt_and_exception	/* 㳰ߤιή */

/* ߤξν */
proc_interrupt:

/*
 *  ߥȥ¿б뤿ᡢϥƥ¸ǹԤ
 *    ˡϡ
 *	ޥPROC_INTERRUPT_SYSˤޤϡؿƽ(proc_interrupt_sys)
 *    Ȥ롣
 *
 *  ƽл˥åȤƤ
 *	t4 : ơ쥸
 *	t5 : 쥸
 *
 *  ˤϡra쥸˲ƤϤʤʤ
 *
 *  Ūʽή졧
 *	1. װȽ
 *	2. ߥޥʥߥȥˤ
 *	3. ߵ
 *	4. ø롼θƽ
 *	5. ߶ػ
 *	6. ߥȥγ׵Υꥢ
 *     (7. join_interrupt_and_exception롣; ؿƽФξ)
 */

#ifdef PROC_INTERRUPT_SYS
	PROC_INTERRUPT_SYS
#else /* PROC_INTERRUPT_SYS */
	ABI_PLA v1, proc_interrupt_sys
	jr	v1
#endif /* PROC_INTERRUPT_SYS */

/* 㳰߽ιή */
join_interrupt_and_exception:
	ABI_PLA t8, nontask_nest
	ld t9, (t8)
	daddiu t9, t9, -1
	sd t9, (t8)		/* ͥȥ ǥ */
	ld      ra, (sp)		/* ra  */
	ABI_PADDIU    sp, sp, ABI_STACK(1*ABI_GPR)
	jr      ra			/* proc_interrupt_and_exeption θƽи
					    */

/*
 *  ư
 *  ǥѥåˤơa5 = p_runtsk ȤʤäƤ뤳Ȥ
 *  åݥ󥿤Ѥ
 */

	.global activate_r

activate_r:
	/* ȤϡCPUåˤʤäƤIEӥå = 0) */
#ifdef SUPPORT_OVR
	ABI_PADDIU sp, sp, -ABI_STACK(1*ABI_GPR)
	sd a5, 0*ABI_GPR(sp)
	ABI_PLA v1, ovrtimer_start
	jalr v1					/* Х󥿥ޤư */
	ld a5, 0*ABI_GPR(sp)
	ABI_PADDIU sp, sp, ABI_STACK(1*ABI_GPR)
#endif /* SUPPORT_OVR */

#if ABI_FPR == 0
#else /* ABI_FPR == 8 */
	li t4, INIT_FCSR
	ctc1 t4, $31
#endif

	/* ߵĤν */
	mfc0    a4, Status

	/* ط */
					/* a5 = p_runtsk (ǥѥå) */
	ABI_PL      a6, TCB_p_tinib(a5)       /* a6 = p_runtsk->p_tinib */

	/* ưϤ */
	ABI_PL      a7, TINIB_task(a6)      /* a7 = p_runtsk->p_tinib->task */

	/* ؤΰʳĥ */
	ABI_PL      a0, TINIB_exinf(a6)     /* a0 = p_runtsk->p_tinib->exinf */

	ABI_PL t4, TCB_p_dominib(a5) /* t4 = p_runtsk->p_dominib */
	lw t5, DOMINIB_domptn(t4) /* t5 = p_runtsk->p_dominib->domptn */
	ABI_PLA t4, rundom
	sw t5, (t4)
	clz t5, t5
	dmtc0 t5, EntryHi
	beq t5, zero, activate_r_0
	ABI_PLA v1, tlb_umode
	jalr v1
	ABI_PL sp, TCB_usp(a5) /* sp = p_runtsk->usp */
	ori a4, a4, (SR_KSU_User | SR_EXL | SR_IE)
	mtc0 a4, Status /* KSU = 2, EXL = 1, IE = 1 */
	dmtc0 a7, EPC
	ABI_PLA ra, call_ext_tsk
	eret

activate_r_0:
	ori a4, a4, SR_IE
	mtc0    a4, Status              /* unlock_cpu  (ߵ) */

	ABI_PLA      ra, ext_tsk             /* Ϥ */

	j       a7                      /* ư */
