/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2005-2010 by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2005-2006 by Japan Aerospace Exploration Agency.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

#ifndef _JAXA_BOARD_H_
#define _JAXA_BOARD_H_

#define JAXA_BOARD

/*
 *  ǥХγƥ١ɥ쥹
 */

/* ɬפʤ顢롣 */

/*
 *  ǥХ˶뤵륯å
 */

/* ޤ˶뤵륯åȿ [kHz]
 *TO_CLOCK 1ߥü(1kHz)ȯ뤿˻ѡ
 * (25MHz = 25000kHz ) */
#define TIMER_CLOCK (1 << TIMER_CLOCK_SHIFT)
#define TIMER_CLOCK_MARGIN (1 << (TIMER_CLOCK_SHIFT - 4))
#define TIMER_CLOCK_SHIFT 14

/*
 *  ǥХγߥޥ
 *
 *  ͥ : () ޣ == ޣ ()
 */

/*
 *  ޣߤγߥޥ
 *  ܼǤϡ޳ߤäȤϡƤγߤػߤƤ롣
 */
#define ICU_IPM_TMR0		MAX_ICU_ILV	/* ߥȥѥǡ */

/*
 *  ޣߤγߥޥ
 *  ܼǤϡ޳ߤäȤϡƤγߤػߤƤ롣
 */
#define ICU_IPM_TMR1		MAX_ICU_ILV	/* ߥȥѥǡ */

#endif /* _JAXA_BOARD_H_ */
