/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2005-     by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2005-2006 by Japan Aerospace Exploration Agency.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

#ifndef _JAXA_MIPS_H_
#define _JAXA_MIPS_H_

/* CP0ϥɤΤλֲԤ */
#define CLEAR_HAZARD_STATUS ssnop; ssnop; ssnop; ssnop; ssnop; ssnop
#define CLEAR_HAZARD_STATUS_INTERRUPT_DISABLE ssnop
#define CLEAR_HAZARD_STATUS_INTERRUPT_ENABLE ssnop; ssnop; ssnop; ssnop
#define CLEAR_HAZARD_CAUSE ssnop
#define CLEAR_HAZARD_CONFIG ssnop; ssnop; ssnop; ssnop; ssnop; ssnop
#define CLEAR_HAZARD_WATCHLO ssnop; ssnop; ssnop

/* Cache Coherency Attributes */
#define CCA_Cacheable_writethrough_nowriteallocate 0
#define CCA_Cacheable_writethrough_writeallocate 1
#define CCA_Uncached_writearound 2
#define CCA_Cacheable_writeback 3
#define CCA_Uncached_accelerated 7

/* Configuration Register (CP0 Register 16, Select 0) */
#define Config_KU (0x7 << 25)
#define Config_KU_Uncached (CCA_Uncached << 25)
#define Config_KU_Cacheable (CCA_Cacheable << 25)
#define Config_K23 (0x7 << 28)
#define Config_K23_Uncached (CCA_Uncached << 28)
#define Config_K23_Cacheable (CCA_Cacheable << 28)

/* å̿ */
#define Index_Store_Tag_I       0x8+0x0
#define Index_Store_Tag_D       0x8+0x1

/*============================================================================*/

#ifndef _MACRO_ONLY

#endif /* _MACRO_ONLY */

#endif /* _JAXA_MIPS_H_  */

