/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2005-2010 by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2005-2006 by Japan Aerospace Exploration Agency.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		åȥƥ¸⥸塼JAXA_MIPS_TENGINEѡ
 */

#include "hrp_kernel.h"
#include <sil.h>
PRI dummy_ipm;

/*
 *  åȥƥ¸ν
 */
void
sys_initialize(void)
{
}

/*
 *  hardware_init_hook constant
 */
const UB mematr_cache_config[4] = {
	MEMATR_CACHE_C(TA_WBACK | TA_CACHE),
	MEMATR_CACHE_C(TA_WBACK | TA_UNCACHE),
	MEMATR_CACHE_C(TA_WTHROUGH | TA_CACHE),
	MEMATR_CACHE_C(TA_WTHROUGH | TA_UNCACHE)
};

/*
 *  tlb_refill constant
 */
const UB mematr_cache_entrylo[4] = {
	MEMATR_CACHE_CDVG(TA_WBACK | TA_CACHE, 0, 0, 0),
	MEMATR_CACHE_CDVG(TA_WBACK | TA_UNCACHE, 0, 0, 0),
	MEMATR_CACHE_CDVG(TA_WTHROUGH | TA_CACHE, 0, 0, 0),
	MEMATR_CACHE_CDVG(TA_WTHROUGH | TA_UNCACHE, 0, 0, 0)
};

/*
 *  tlb_refill variable
 */
UW tlb_refill_register[6];

/*
 *  tlb_umode variable
 */
VP tlb_umode_task;
