/*  This file is generated from svc.def by gensvc.  */

#ifndef _KERNEL_SVC_H_
#define _KERNEL_SVC_H_

#ifndef CALSVC_TRAP

#define ini_mpf _kernel_ini_mpf
#define ini_mtx _kernel_ini_mtx
#define ini_mbx _kernel_ini_mbx
#define ini_dtq _kernel_ini_dtq
#define ini_flg _kernel_ini_flg
#define ini_sem _kernel_ini_sem
#define ext_ker _kernel_ext_ker
#define get_utm _kernel_get_utm
#define sns_ker _kernel_sns_ker
#define xsns_xpn _kernel_xsns_xpn
#define xsns_dpn _kernel_xsns_dpn
#define prb_mem _kernel_prb_mem
#define ref_ovr _kernel_ref_ovr
#define stp_ovr _kernel_stp_ovr
#define sta_ovr _kernel_sta_ovr
#define ref_alm _kernel_ref_alm
#define stp_alm _kernel_stp_alm
#define sta_alm _kernel_sta_alm
#define ref_mtx _kernel_ref_mtx
#define tloc_mtx _kernel_tloc_mtx
#define ploc_mtx _kernel_ploc_mtx
#define loc_mtx _kernel_loc_mtx
#define unl_mtx _kernel_unl_mtx
#define istp_alm _kernel_istp_alm
#define ista_alm _kernel_ista_alm
#define isig_tim _kernel_isig_tim
#define iunl_cpu _kernel_iunl_cpu
#define iloc_cpu _kernel_iloc_cpu
#define iget_tid _kernel_iget_tid
#define irot_rdq _kernel_irot_rdq
#define ifsnd_dtq _kernel_ifsnd_dtq
#define ipsnd_dtq _kernel_ipsnd_dtq
#define iset_flg _kernel_iset_flg
#define isig_sem _kernel_isig_sem
#define iras_tex _kernel_iras_tex
#define irel_wai _kernel_irel_wai
#define iwup_tsk _kernel_iwup_tsk
#define iact_tsk _kernel_iact_tsk
#define get_ipm _kernel_get_ipm
#define chg_ipm _kernel_chg_ipm
#define ena_int _kernel_ena_int
#define dis_int _kernel_dis_int
#define sns_dpn _kernel_sns_dpn
#define sns_dsp _kernel_sns_dsp
#define sns_loc _kernel_sns_loc
#define sns_ctx _kernel_sns_ctx
#define ena_dsp _kernel_ena_dsp
#define dis_dsp _kernel_dis_dsp
#define unl_cpu _kernel_unl_cpu
#define loc_cpu _kernel_loc_cpu
#define get_did _kernel_get_did
#define get_tid _kernel_get_tid
#define rot_rdq _kernel_rot_rdq
#define ref_cyc _kernel_ref_cyc
#define stp_cyc _kernel_stp_cyc
#define sta_cyc _kernel_sta_cyc
#define get_tim _kernel_get_tim
#define set_tim _kernel_set_tim
#define ref_mpf _kernel_ref_mpf
#define tget_mpf _kernel_tget_mpf
#define pget_mpf _kernel_pget_mpf
#define get_mpf _kernel_get_mpf
#define rel_mpf _kernel_rel_mpf
#define ref_mbx _kernel_ref_mbx
#define trcv_mbx _kernel_trcv_mbx
#define prcv_mbx _kernel_prcv_mbx
#define rcv_mbx _kernel_rcv_mbx
#define snd_mbx _kernel_snd_mbx
#define ref_dtq _kernel_ref_dtq
#define trcv_dtq _kernel_trcv_dtq
#define prcv_dtq _kernel_prcv_dtq
#define rcv_dtq _kernel_rcv_dtq
#define fsnd_dtq _kernel_fsnd_dtq
#define tsnd_dtq _kernel_tsnd_dtq
#define psnd_dtq _kernel_psnd_dtq
#define snd_dtq _kernel_snd_dtq
#define ref_flg _kernel_ref_flg
#define twai_flg _kernel_twai_flg
#define pol_flg _kernel_pol_flg
#define wai_flg _kernel_wai_flg
#define clr_flg _kernel_clr_flg
#define set_flg _kernel_set_flg
#define ref_sem _kernel_ref_sem
#define twai_sem _kernel_twai_sem
#define pol_sem _kernel_pol_sem
#define wai_sem _kernel_wai_sem
#define sig_sem _kernel_sig_sem
#define ref_tex _kernel_ref_tex
#define sns_tex _kernel_sns_tex
#define ena_tex _kernel_ena_tex
#define dis_tex _kernel_dis_tex
#define ras_tex _kernel_ras_tex
#define dly_tsk _kernel_dly_tsk
#define frsm_tsk _kernel_frsm_tsk
#define rsm_tsk _kernel_rsm_tsk
#define sus_tsk _kernel_sus_tsk
#define rel_wai _kernel_rel_wai
#define can_wup _kernel_can_wup
#define wup_tsk _kernel_wup_tsk
#define tslp_tsk _kernel_tslp_tsk
#define slp_tsk _kernel_slp_tsk
#define ref_tsk _kernel_ref_tsk
#define get_pri _kernel_get_pri
#define chg_pri _kernel_chg_pri
#define ter_tsk _kernel_ter_tsk
#define ext_tsk _kernel_ext_tsk
#define can_act _kernel_can_act
#define act_tsk _kernel_act_tsk
#define cal_svc _kernel_cal_svc

#ifdef LABEL_ASM

#define _ini_mpf __kernel_ini_mpf
#define _ini_mtx __kernel_ini_mtx
#define _ini_mbx __kernel_ini_mbx
#define _ini_dtq __kernel_ini_dtq
#define _ini_flg __kernel_ini_flg
#define _ini_sem __kernel_ini_sem
#define _ext_ker __kernel_ext_ker
#define _get_utm __kernel_get_utm
#define _sns_ker __kernel_sns_ker
#define _xsns_xpn __kernel_xsns_xpn
#define _xsns_dpn __kernel_xsns_dpn
#define _prb_mem __kernel_prb_mem
#define _ref_ovr __kernel_ref_ovr
#define _stp_ovr __kernel_stp_ovr
#define _sta_ovr __kernel_sta_ovr
#define _ref_alm __kernel_ref_alm
#define _stp_alm __kernel_stp_alm
#define _sta_alm __kernel_sta_alm
#define _ref_mtx __kernel_ref_mtx
#define _tloc_mtx __kernel_tloc_mtx
#define _ploc_mtx __kernel_ploc_mtx
#define _loc_mtx __kernel_loc_mtx
#define _unl_mtx __kernel_unl_mtx
#define _istp_alm __kernel_istp_alm
#define _ista_alm __kernel_ista_alm
#define _isig_tim __kernel_isig_tim
#define _iunl_cpu __kernel_iunl_cpu
#define _iloc_cpu __kernel_iloc_cpu
#define _iget_tid __kernel_iget_tid
#define _irot_rdq __kernel_irot_rdq
#define _ifsnd_dtq __kernel_ifsnd_dtq
#define _ipsnd_dtq __kernel_ipsnd_dtq
#define _iset_flg __kernel_iset_flg
#define _isig_sem __kernel_isig_sem
#define _iras_tex __kernel_iras_tex
#define _irel_wai __kernel_irel_wai
#define _iwup_tsk __kernel_iwup_tsk
#define _iact_tsk __kernel_iact_tsk
#define _get_ipm __kernel_get_ipm
#define _chg_ipm __kernel_chg_ipm
#define _ena_int __kernel_ena_int
#define _dis_int __kernel_dis_int
#define _sns_dpn __kernel_sns_dpn
#define _sns_dsp __kernel_sns_dsp
#define _sns_loc __kernel_sns_loc
#define _sns_ctx __kernel_sns_ctx
#define _ena_dsp __kernel_ena_dsp
#define _dis_dsp __kernel_dis_dsp
#define _unl_cpu __kernel_unl_cpu
#define _loc_cpu __kernel_loc_cpu
#define _get_did __kernel_get_did
#define _get_tid __kernel_get_tid
#define _rot_rdq __kernel_rot_rdq
#define _ref_cyc __kernel_ref_cyc
#define _stp_cyc __kernel_stp_cyc
#define _sta_cyc __kernel_sta_cyc
#define _get_tim __kernel_get_tim
#define _set_tim __kernel_set_tim
#define _ref_mpf __kernel_ref_mpf
#define _tget_mpf __kernel_tget_mpf
#define _pget_mpf __kernel_pget_mpf
#define _get_mpf __kernel_get_mpf
#define _rel_mpf __kernel_rel_mpf
#define _ref_mbx __kernel_ref_mbx
#define _trcv_mbx __kernel_trcv_mbx
#define _prcv_mbx __kernel_prcv_mbx
#define _rcv_mbx __kernel_rcv_mbx
#define _snd_mbx __kernel_snd_mbx
#define _ref_dtq __kernel_ref_dtq
#define _trcv_dtq __kernel_trcv_dtq
#define _prcv_dtq __kernel_prcv_dtq
#define _rcv_dtq __kernel_rcv_dtq
#define _fsnd_dtq __kernel_fsnd_dtq
#define _tsnd_dtq __kernel_tsnd_dtq
#define _psnd_dtq __kernel_psnd_dtq
#define _snd_dtq __kernel_snd_dtq
#define _ref_flg __kernel_ref_flg
#define _twai_flg __kernel_twai_flg
#define _pol_flg __kernel_pol_flg
#define _wai_flg __kernel_wai_flg
#define _clr_flg __kernel_clr_flg
#define _set_flg __kernel_set_flg
#define _ref_sem __kernel_ref_sem
#define _twai_sem __kernel_twai_sem
#define _pol_sem __kernel_pol_sem
#define _wai_sem __kernel_wai_sem
#define _sig_sem __kernel_sig_sem
#define _ref_tex __kernel_ref_tex
#define _sns_tex __kernel_sns_tex
#define _ena_tex __kernel_ena_tex
#define _dis_tex __kernel_dis_tex
#define _ras_tex __kernel_ras_tex
#define _dly_tsk __kernel_dly_tsk
#define _frsm_tsk __kernel_frsm_tsk
#define _rsm_tsk __kernel_rsm_tsk
#define _sus_tsk __kernel_sus_tsk
#define _rel_wai __kernel_rel_wai
#define _can_wup __kernel_can_wup
#define _wup_tsk __kernel_wup_tsk
#define _tslp_tsk __kernel_tslp_tsk
#define _slp_tsk __kernel_slp_tsk
#define _ref_tsk __kernel_ref_tsk
#define _get_pri __kernel_get_pri
#define _chg_pri __kernel_chg_pri
#define _ter_tsk __kernel_ter_tsk
#define _ext_tsk __kernel_ext_tsk
#define _can_act __kernel_can_act
#define _act_tsk __kernel_act_tsk

#endif /* LABEL_ASM */
#ifndef _MACRO_ONLY

extern ER ini_mpf(ID mpfid) throw();
extern ER ini_mtx(ID mtxid) throw();
extern ER ini_mbx(ID mbxid) throw();
extern ER ini_dtq(ID dtqid) throw();
extern ER ini_flg(ID flgid) throw();
extern ER ini_sem(ID semid) throw();
extern ER ext_ker(void) throw();
extern ER get_utm(SYSUTIM *p_sysutim) throw();
extern BOOL sns_ker(void) throw();
extern BOOL xsns_xpn(VP p_excinf) throw();
extern BOOL xsns_dpn(VP p_excinf) throw();
extern ER prb_mem(VP base, SIZE size, ID domid, ID tskid, MODE pmmode) throw();
extern ER ref_ovr(ID tskid, T_ROVR *pk_rovr) throw();
extern ER stp_ovr(ID tskid) throw();
extern ER sta_ovr(ID tskid, OVRTIM ovrtim) throw();
extern ER ref_alm(ID almid, T_RALM *pk_ralm) throw();
extern ER stp_alm(ID almid) throw();
extern ER sta_alm(ID almid, RELTIM almtim) throw();
extern ER ref_mtx(ID mtxid, T_RMTX *pk_rmtx) throw();
extern ER tloc_mtx(ID mtxid, TMO tmout) throw();
extern ER ploc_mtx(ID mtxid) throw();
extern ER loc_mtx(ID mtxid) throw();
extern ER unl_mtx(ID mtxid) throw();
extern ER istp_alm(ID almid) throw();
extern ER ista_alm(ID almid, RELTIM almtim) throw();
extern ER isig_tim(void) throw();
extern ER iunl_cpu(void) throw();
extern ER iloc_cpu(void) throw();
extern ER iget_tid(ID *p_tskid) throw();
extern ER irot_rdq(PRI tskpri) throw();
extern ER ifsnd_dtq(ID dtqid, VP_INT data) throw();
extern ER ipsnd_dtq(ID dtqid, VP_INT data) throw();
extern ER iset_flg(ID flgid, FLGPTN setptn) throw();
extern ER isig_sem(ID semid) throw();
extern ER iras_tex(ID tskid, TEXPTN rasptn) throw();
extern ER irel_wai(ID tskid) throw();
extern ER iwup_tsk(ID tskid) throw();
extern ER iact_tsk(ID tskid) throw();
extern ER get_ipm(PRI *p_intpri) throw();
extern ER chg_ipm(PRI intpri) throw();
extern ER ena_int(INTNO intno) throw();
extern ER dis_int(INTNO intno) throw();
extern BOOL sns_dpn(void) throw();
extern BOOL sns_dsp(void) throw();
extern BOOL sns_loc(void) throw();
extern BOOL sns_ctx(void) throw();
extern ER ena_dsp(void) throw();
extern ER dis_dsp(void) throw();
extern ER unl_cpu(void) throw();
extern ER loc_cpu(void) throw();
extern ER get_did(ID *p_domid) throw();
extern ER get_tid(ID *p_tskid) throw();
extern ER rot_rdq(PRI tskpri) throw();
extern ER ref_cyc(ID cycid, T_RCYC *pk_rcyc) throw();
extern ER stp_cyc(ID cycid) throw();
extern ER sta_cyc(ID cycid) throw();
extern ER get_tim(SYSTIM *p_systim) throw();
extern ER set_tim(const SYSTIM *p_systim) throw();
extern ER ref_mpf(ID mpfid, T_RMPF *pk_rmpf) throw();
extern ER tget_mpf(ID mpfid, VP *p_blk, TMO tmout) throw();
extern ER pget_mpf(ID mpfid, VP *p_blk) throw();
extern ER get_mpf(ID mpfid, VP *p_blk) throw();
extern ER rel_mpf(ID mpfid, VP blk) throw();
extern ER ref_mbx(ID mbxid, T_RMBX *pk_rmbx) throw();
extern ER trcv_mbx(ID mbxid, T_MSG **ppk_msg, TMO tmout) throw();
extern ER prcv_mbx(ID mbxid, T_MSG **ppk_msg) throw();
extern ER rcv_mbx(ID mbxid, T_MSG **ppk_msg) throw();
extern ER snd_mbx(ID mbxid, T_MSG *pk_msg) throw();
extern ER ref_dtq(ID dtqid, T_RDTQ *pk_rdtq) throw();
extern ER trcv_dtq(ID dtqid, VP_INT *p_data, TMO tmout) throw();
extern ER prcv_dtq(ID dtqid, VP_INT *p_data) throw();
extern ER rcv_dtq(ID dtqid, VP_INT *p_data) throw();
extern ER fsnd_dtq(ID dtqid, VP_INT data) throw();
extern ER tsnd_dtq(ID dtqid, VP_INT data, TMO tmout) throw();
extern ER psnd_dtq(ID dtqid, VP_INT data) throw();
extern ER snd_dtq(ID dtqid, VP_INT data) throw();
extern ER ref_flg(ID flgid, T_RFLG *pk_rflg) throw();
extern ER twai_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn, TMO tmout) throw();
extern ER pol_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn) throw();
extern ER wai_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn) throw();
extern ER clr_flg(ID flgid, FLGPTN clrptn) throw();
extern ER set_flg(ID flgid, FLGPTN setptn) throw();
extern ER ref_sem(ID semid, T_RSEM *pk_rsem) throw();
extern ER twai_sem(ID semid, TMO tmout) throw();
extern ER pol_sem(ID semid) throw();
extern ER wai_sem(ID semid) throw();
extern ER sig_sem(ID semid) throw();
extern ER ref_tex(ID tskid, T_RTEX *pk_rtex) throw();
extern BOOL sns_tex(void) throw();
extern ER ena_tex(void) throw();
extern ER dis_tex(void) throw();
extern ER ras_tex(ID tskid, TEXPTN rasptn) throw();
extern ER dly_tsk(RELTIM dlytim) throw();
extern ER frsm_tsk(ID tskid) throw();
extern ER rsm_tsk(ID tskid) throw();
extern ER sus_tsk(ID tskid) throw();
extern ER rel_wai(ID tskid) throw();
extern ER_UINT can_wup(ID tskid) throw();
extern ER wup_tsk(ID tskid) throw();
extern ER tslp_tsk(TMO tmout) throw();
extern ER slp_tsk(void) throw();
extern ER ref_tsk(ID tskid, T_RTSK *pk_rtsk) throw();
extern ER get_pri(ID tskid, PRI *p_tskpri) throw();
extern ER chg_pri(ID tskid, PRI tskpri) throw();
extern ER ter_tsk(ID tskid) throw();
extern ER ext_tsk(void) throw();
extern ER_UINT can_act(ID tskid) throw();
extern ER act_tsk(ID tskid) throw();
extern ER_UINT cal_svc(FN fncd, VP_INT par1, VP_INT par2, VP_INT par3,
		VP_INT par4, VP_INT par5) throw();

#endif /* _MACRO_ONLY */
#else /* CALSVC_TRAP */
#ifndef _MACRO_ONLY

#if defined(__GNUC__) && !defined(__ghs__)

Inline ER_UINT
cal_svc(FN fncd, VP_INT par1, VP_INT par2, VP_INT par3,
											VP_INT par4, VP_INT par5)
{
	if (fncd > 0) {
		CAL_SVC_5M(ER_UINT, fncd, VP_INT, par1, VP_INT, par2, VP_INT, par3,
											VP_INT, par4, VP_INT, par5);
	}
	else {
		return(E_RSFN);
	}
}

Inline ER
ini_mpf(ID mpfid)
{
	CAL_SVC_1(ER, TFN_INI_MPF, ID, mpfid);
}

Inline ER
ini_mtx(ID mtxid)
{
	CAL_SVC_1(ER, TFN_INI_MTX, ID, mtxid);
}

Inline ER
ini_mbx(ID mbxid)
{
	CAL_SVC_1(ER, TFN_INI_MBX, ID, mbxid);
}

Inline ER
ini_dtq(ID dtqid)
{
	CAL_SVC_1(ER, TFN_INI_DTQ, ID, dtqid);
}

Inline ER
ini_flg(ID flgid)
{
	CAL_SVC_1(ER, TFN_INI_FLG, ID, flgid);
}

Inline ER
ini_sem(ID semid)
{
	CAL_SVC_1(ER, TFN_INI_SEM, ID, semid);
}

Inline ER
ext_ker(void)
{
	CAL_SVC_0(ER, TFN_EXT_KER);
}

Inline ER
get_utm(SYSUTIM *p_sysutim)
{
	CAL_SVC_1M(ER, TFN_GET_UTM, SYSUTIM *, p_sysutim);
}

Inline BOOL
sns_ker(void)
{
	CAL_SVC_0(BOOL, TFN_SNS_KER);
}

Inline BOOL
xsns_xpn(VP p_excinf)
{
	CAL_SVC_1(BOOL, TFN_XSNS_XPN, VP, p_excinf);
}

Inline BOOL
xsns_dpn(VP p_excinf)
{
	CAL_SVC_1(BOOL, TFN_XSNS_DPN, VP, p_excinf);
}

Inline ER
prb_mem(VP base, SIZE size, ID domid, ID tskid, MODE pmmode)
{
	CAL_SVC_5(ER, TFN_PRB_MEM, VP, base, SIZE, size, ID, domid, ID, tskid, MODE, pmmode);
}

Inline ER
ref_ovr(ID tskid, T_ROVR *pk_rovr)
{
	CAL_SVC_2M(ER, TFN_REF_OVR, ID, tskid, T_ROVR *, pk_rovr);
}

Inline ER
stp_ovr(ID tskid)
{
	CAL_SVC_1(ER, TFN_STP_OVR, ID, tskid);
}

Inline ER
sta_ovr(ID tskid, OVRTIM ovrtim)
{
	CAL_SVC_2(ER, TFN_STA_OVR, ID, tskid, OVRTIM, ovrtim);
}

Inline ER
ref_alm(ID almid, T_RALM *pk_ralm)
{
	CAL_SVC_2M(ER, TFN_REF_ALM, ID, almid, T_RALM *, pk_ralm);
}

Inline ER
stp_alm(ID almid)
{
	CAL_SVC_1(ER, TFN_STP_ALM, ID, almid);
}

Inline ER
sta_alm(ID almid, RELTIM almtim)
{
	CAL_SVC_2(ER, TFN_STA_ALM, ID, almid, RELTIM, almtim);
}

Inline ER
ref_mtx(ID mtxid, T_RMTX *pk_rmtx)
{
	CAL_SVC_2M(ER, TFN_REF_MTX, ID, mtxid, T_RMTX *, pk_rmtx);
}

Inline ER
tloc_mtx(ID mtxid, TMO tmout)
{
	CAL_SVC_2(ER, TFN_TLOC_MTX, ID, mtxid, TMO, tmout);
}

Inline ER
ploc_mtx(ID mtxid)
{
	CAL_SVC_1(ER, TFN_PLOC_MTX, ID, mtxid);
}

Inline ER
loc_mtx(ID mtxid)
{
	CAL_SVC_1(ER, TFN_LOC_MTX, ID, mtxid);
}

Inline ER
unl_mtx(ID mtxid)
{
	CAL_SVC_1(ER, TFN_UNL_MTX, ID, mtxid);
}

Inline ER
istp_alm(ID almid)
{
	CAL_SVC_1(ER, TFN_ISTP_ALM, ID, almid);
}

Inline ER
ista_alm(ID almid, RELTIM almtim)
{
	CAL_SVC_2(ER, TFN_ISTA_ALM, ID, almid, RELTIM, almtim);
}

Inline ER
isig_tim(void)
{
	CAL_SVC_0(ER, TFN_ISIG_TIM);
}

Inline ER
iunl_cpu(void)
{
	CAL_SVC_0(ER, TFN_IUNL_CPU);
}

Inline ER
iloc_cpu(void)
{
	CAL_SVC_0(ER, TFN_ILOC_CPU);
}

Inline ER
iget_tid(ID *p_tskid)
{
	CAL_SVC_1M(ER, TFN_IGET_TID, ID *, p_tskid);
}

Inline ER
irot_rdq(PRI tskpri)
{
	CAL_SVC_1(ER, TFN_IROT_RDQ, PRI, tskpri);
}

Inline ER
ifsnd_dtq(ID dtqid, VP_INT data)
{
	CAL_SVC_2(ER, TFN_IFSND_DTQ, ID, dtqid, VP_INT, data);
}

Inline ER
ipsnd_dtq(ID dtqid, VP_INT data)
{
	CAL_SVC_2(ER, TFN_IPSND_DTQ, ID, dtqid, VP_INT, data);
}

Inline ER
iset_flg(ID flgid, FLGPTN setptn)
{
	CAL_SVC_2(ER, TFN_ISET_FLG, ID, flgid, FLGPTN, setptn);
}

Inline ER
isig_sem(ID semid)
{
	CAL_SVC_1(ER, TFN_ISIG_SEM, ID, semid);
}

Inline ER
iras_tex(ID tskid, TEXPTN rasptn)
{
	CAL_SVC_2(ER, TFN_IRAS_TEX, ID, tskid, TEXPTN, rasptn);
}

Inline ER
irel_wai(ID tskid)
{
	CAL_SVC_1(ER, TFN_IREL_WAI, ID, tskid);
}

Inline ER
iwup_tsk(ID tskid)
{
	CAL_SVC_1(ER, TFN_IWUP_TSK, ID, tskid);
}

Inline ER
iact_tsk(ID tskid)
{
	CAL_SVC_1(ER, TFN_IACT_TSK, ID, tskid);
}

Inline ER
get_ipm(PRI *p_intpri)
{
	CAL_SVC_1M(ER, TFN_GET_IPM, PRI *, p_intpri);
}

Inline ER
chg_ipm(PRI intpri)
{
	CAL_SVC_1(ER, TFN_CHG_IPM, PRI, intpri);
}

Inline ER
ena_int(INTNO intno)
{
	CAL_SVC_1(ER, TFN_ENA_INT, INTNO, intno);
}

Inline ER
dis_int(INTNO intno)
{
	CAL_SVC_1(ER, TFN_DIS_INT, INTNO, intno);
}

Inline BOOL
sns_dpn(void)
{
	CAL_SVC_0(BOOL, TFN_SNS_DPN);
}

Inline BOOL
sns_dsp(void)
{
	CAL_SVC_0(BOOL, TFN_SNS_DSP);
}

Inline BOOL
sns_loc(void)
{
	CAL_SVC_0(BOOL, TFN_SNS_LOC);
}

Inline BOOL
sns_ctx(void)
{
	CAL_SVC_0(BOOL, TFN_SNS_CTX);
}

Inline ER
ena_dsp(void)
{
	CAL_SVC_0(ER, TFN_ENA_DSP);
}

Inline ER
dis_dsp(void)
{
	CAL_SVC_0(ER, TFN_DIS_DSP);
}

Inline ER
unl_cpu(void)
{
	CAL_SVC_0(ER, TFN_UNL_CPU);
}

Inline ER
loc_cpu(void)
{
	CAL_SVC_0(ER, TFN_LOC_CPU);
}

Inline ER
get_did(ID *p_domid)
{
	CAL_SVC_1M(ER, TFN_GET_DID, ID *, p_domid);
}

Inline ER
get_tid(ID *p_tskid)
{
	CAL_SVC_1M(ER, TFN_GET_TID, ID *, p_tskid);
}

Inline ER
rot_rdq(PRI tskpri)
{
	CAL_SVC_1(ER, TFN_ROT_RDQ, PRI, tskpri);
}

Inline ER
ref_cyc(ID cycid, T_RCYC *pk_rcyc)
{
	CAL_SVC_2M(ER, TFN_REF_CYC, ID, cycid, T_RCYC *, pk_rcyc);
}

Inline ER
stp_cyc(ID cycid)
{
	CAL_SVC_1(ER, TFN_STP_CYC, ID, cycid);
}

Inline ER
sta_cyc(ID cycid)
{
	CAL_SVC_1(ER, TFN_STA_CYC, ID, cycid);
}

Inline ER
get_tim(SYSTIM *p_systim)
{
	CAL_SVC_1M(ER, TFN_GET_TIM, SYSTIM *, p_systim);
}

Inline ER
set_tim(const SYSTIM *p_systim)
{
	CAL_SVC_1(ER, TFN_SET_TIM, const SYSTIM *, p_systim);
}

Inline ER
ref_mpf(ID mpfid, T_RMPF *pk_rmpf)
{
	CAL_SVC_2M(ER, TFN_REF_MPF, ID, mpfid, T_RMPF *, pk_rmpf);
}

Inline ER
tget_mpf(ID mpfid, VP *p_blk, TMO tmout)
{
	CAL_SVC_3M(ER, TFN_TGET_MPF, ID, mpfid, VP *, p_blk, TMO, tmout);
}

Inline ER
pget_mpf(ID mpfid, VP *p_blk)
{
	CAL_SVC_2M(ER, TFN_PGET_MPF, ID, mpfid, VP *, p_blk);
}

Inline ER
get_mpf(ID mpfid, VP *p_blk)
{
	CAL_SVC_2M(ER, TFN_GET_MPF, ID, mpfid, VP *, p_blk);
}

Inline ER
rel_mpf(ID mpfid, VP blk)
{
	CAL_SVC_2(ER, TFN_REL_MPF, ID, mpfid, VP, blk);
}

Inline ER
ref_mbx(ID mbxid, T_RMBX *pk_rmbx)
{
	CAL_SVC_2M(ER, TFN_REF_MBX, ID, mbxid, T_RMBX *, pk_rmbx);
}

Inline ER
trcv_mbx(ID mbxid, T_MSG **ppk_msg, TMO tmout)
{
	CAL_SVC_3M(ER, TFN_TRCV_MBX, ID, mbxid, T_MSG **, ppk_msg, TMO, tmout);
}

Inline ER
prcv_mbx(ID mbxid, T_MSG **ppk_msg)
{
	CAL_SVC_2M(ER, TFN_PRCV_MBX, ID, mbxid, T_MSG **, ppk_msg);
}

Inline ER
rcv_mbx(ID mbxid, T_MSG **ppk_msg)
{
	CAL_SVC_2M(ER, TFN_RCV_MBX, ID, mbxid, T_MSG **, ppk_msg);
}

Inline ER
snd_mbx(ID mbxid, T_MSG *pk_msg)
{
	CAL_SVC_2(ER, TFN_SND_MBX, ID, mbxid, T_MSG *, pk_msg);
}

Inline ER
ref_dtq(ID dtqid, T_RDTQ *pk_rdtq)
{
	CAL_SVC_2M(ER, TFN_REF_DTQ, ID, dtqid, T_RDTQ *, pk_rdtq);
}

Inline ER
trcv_dtq(ID dtqid, VP_INT *p_data, TMO tmout)
{
	CAL_SVC_3M(ER, TFN_TRCV_DTQ, ID, dtqid, VP_INT *, p_data, TMO, tmout);
}

Inline ER
prcv_dtq(ID dtqid, VP_INT *p_data)
{
	CAL_SVC_2M(ER, TFN_PRCV_DTQ, ID, dtqid, VP_INT *, p_data);
}

Inline ER
rcv_dtq(ID dtqid, VP_INT *p_data)
{
	CAL_SVC_2M(ER, TFN_RCV_DTQ, ID, dtqid, VP_INT *, p_data);
}

Inline ER
fsnd_dtq(ID dtqid, VP_INT data)
{
	CAL_SVC_2(ER, TFN_FSND_DTQ, ID, dtqid, VP_INT, data);
}

Inline ER
tsnd_dtq(ID dtqid, VP_INT data, TMO tmout)
{
	CAL_SVC_3(ER, TFN_TSND_DTQ, ID, dtqid, VP_INT, data, TMO, tmout);
}

Inline ER
psnd_dtq(ID dtqid, VP_INT data)
{
	CAL_SVC_2(ER, TFN_PSND_DTQ, ID, dtqid, VP_INT, data);
}

Inline ER
snd_dtq(ID dtqid, VP_INT data)
{
	CAL_SVC_2(ER, TFN_SND_DTQ, ID, dtqid, VP_INT, data);
}

Inline ER
ref_flg(ID flgid, T_RFLG *pk_rflg)
{
	CAL_SVC_2M(ER, TFN_REF_FLG, ID, flgid, T_RFLG *, pk_rflg);
}

Inline ER
twai_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn, TMO tmout)
{
	CAL_SVC_5M(ER, TFN_TWAI_FLG, ID, flgid, FLGPTN, waiptn, MODE, wfmode, FLGPTN *, p_flgptn, TMO, tmout);
}

Inline ER
pol_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn)
{
	CAL_SVC_4M(ER, TFN_POL_FLG, ID, flgid, FLGPTN, waiptn, MODE, wfmode, FLGPTN *, p_flgptn);
}

Inline ER
wai_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn)
{
	CAL_SVC_4M(ER, TFN_WAI_FLG, ID, flgid, FLGPTN, waiptn, MODE, wfmode, FLGPTN *, p_flgptn);
}

Inline ER
clr_flg(ID flgid, FLGPTN clrptn)
{
	CAL_SVC_2(ER, TFN_CLR_FLG, ID, flgid, FLGPTN, clrptn);
}

Inline ER
set_flg(ID flgid, FLGPTN setptn)
{
	CAL_SVC_2(ER, TFN_SET_FLG, ID, flgid, FLGPTN, setptn);
}

Inline ER
ref_sem(ID semid, T_RSEM *pk_rsem)
{
	CAL_SVC_2M(ER, TFN_REF_SEM, ID, semid, T_RSEM *, pk_rsem);
}

Inline ER
twai_sem(ID semid, TMO tmout)
{
	CAL_SVC_2(ER, TFN_TWAI_SEM, ID, semid, TMO, tmout);
}

Inline ER
pol_sem(ID semid)
{
	CAL_SVC_1(ER, TFN_POL_SEM, ID, semid);
}

Inline ER
wai_sem(ID semid)
{
	CAL_SVC_1(ER, TFN_WAI_SEM, ID, semid);
}

Inline ER
sig_sem(ID semid)
{
	CAL_SVC_1(ER, TFN_SIG_SEM, ID, semid);
}

Inline ER
ref_tex(ID tskid, T_RTEX *pk_rtex)
{
	CAL_SVC_2M(ER, TFN_REF_TEX, ID, tskid, T_RTEX *, pk_rtex);
}

Inline BOOL
sns_tex(void)
{
	CAL_SVC_0(BOOL, TFN_SNS_TEX);
}

Inline ER
ena_tex(void)
{
	CAL_SVC_0(ER, TFN_ENA_TEX);
}

Inline ER
dis_tex(void)
{
	CAL_SVC_0(ER, TFN_DIS_TEX);
}

Inline ER
ras_tex(ID tskid, TEXPTN rasptn)
{
	CAL_SVC_2(ER, TFN_RAS_TEX, ID, tskid, TEXPTN, rasptn);
}

Inline ER
dly_tsk(RELTIM dlytim)
{
	CAL_SVC_1(ER, TFN_DLY_TSK, RELTIM, dlytim);
}

Inline ER
frsm_tsk(ID tskid)
{
	CAL_SVC_1(ER, TFN_FRSM_TSK, ID, tskid);
}

Inline ER
rsm_tsk(ID tskid)
{
	CAL_SVC_1(ER, TFN_RSM_TSK, ID, tskid);
}

Inline ER
sus_tsk(ID tskid)
{
	CAL_SVC_1(ER, TFN_SUS_TSK, ID, tskid);
}

Inline ER
rel_wai(ID tskid)
{
	CAL_SVC_1(ER, TFN_REL_WAI, ID, tskid);
}

Inline ER_UINT
can_wup(ID tskid)
{
	CAL_SVC_1(ER_UINT, TFN_CAN_WUP, ID, tskid);
}

Inline ER
wup_tsk(ID tskid)
{
	CAL_SVC_1(ER, TFN_WUP_TSK, ID, tskid);
}

Inline ER
tslp_tsk(TMO tmout)
{
	CAL_SVC_1(ER, TFN_TSLP_TSK, TMO, tmout);
}

Inline ER
slp_tsk(void)
{
	CAL_SVC_0(ER, TFN_SLP_TSK);
}

Inline ER
ref_tsk(ID tskid, T_RTSK *pk_rtsk)
{
	CAL_SVC_2M(ER, TFN_REF_TSK, ID, tskid, T_RTSK *, pk_rtsk);
}

Inline ER
get_pri(ID tskid, PRI *p_tskpri)
{
	CAL_SVC_2M(ER, TFN_GET_PRI, ID, tskid, PRI *, p_tskpri);
}

Inline ER
chg_pri(ID tskid, PRI tskpri)
{
	CAL_SVC_2(ER, TFN_CHG_PRI, ID, tskid, PRI, tskpri);
}

Inline ER
ter_tsk(ID tskid)
{
	CAL_SVC_1(ER, TFN_TER_TSK, ID, tskid);
}

Inline ER
ext_tsk(void)
{
	CAL_SVC_0(ER, TFN_EXT_TSK);
}

Inline ER_UINT
can_act(ID tskid)
{
	CAL_SVC_1(ER_UINT, TFN_CAN_ACT, ID, tskid);
}

Inline ER
act_tsk(ID tskid)
{
	CAL_SVC_1(ER, TFN_ACT_TSK, ID, tskid);
}

#elif defined(__ghs__) /* !defined(__GNUC__) */

Inline ER_UINT
cal_svc(FN fncd, VP_INT par1, VP_INT par2, VP_INT par3, VP_INT par4, VP_INT par5)
{
	if (fncd > 0) {
		return (ER_UINT)CAL_SVC_5M(fncd, par1, par2, par3, par4, par5);
	}
	else {
		return(E_RSFN);
	}
}

Inline ER
ini_mpf(ID mpfid)
{
	return (ER)CAL_SVC_1(TFN_INI_MPF, mpfid);
}

Inline ER
ini_mtx(ID mtxid)
{
	return (ER)CAL_SVC_1(TFN_INI_MTX, mtxid);
}

Inline ER
ini_mbx(ID mbxid)
{
	return (ER)CAL_SVC_1(TFN_INI_MBX, mbxid);
}

Inline ER
ini_dtq(ID dtqid)
{
	return (ER)CAL_SVC_1(TFN_INI_DTQ, dtqid);
}

Inline ER
ini_flg(ID flgid)
{
	return (ER)CAL_SVC_1(TFN_INI_FLG, flgid);
}

Inline ER
ini_sem(ID semid)
{
	return (ER)CAL_SVC_1(TFN_INI_SEM, semid);
}

Inline ER
ext_ker(void)
{
	return (ER)CAL_SVC_0(TFN_EXT_KER);
}

Inline ER
get_utm(SYSUTIM *p_sysutim)
{
	return (ER)CAL_SVC_1M(TFN_GET_UTM, p_sysutim);
}

Inline BOOL
sns_ker(void)
{
	return (BOOL)CAL_SVC_0(TFN_SNS_KER);
}

Inline BOOL
xsns_xpn(VP p_excinf)
{
	return (BOOL)CAL_SVC_1(TFN_XSNS_XPN, p_excinf);
}

Inline BOOL
xsns_dpn(VP p_excinf)
{
	return (BOOL)CAL_SVC_1(TFN_XSNS_DPN, p_excinf);
}

Inline ER
prb_mem(VP base, SIZE size, ID domid, ID tskid, MODE pmmode)
{
	return (ER)CAL_SVC_5(TFN_PRB_MEM, base, size, domid, tskid, pmmode);
}

Inline ER
ref_ovr(ID tskid, T_ROVR *pk_rovr)
{
	return (ER)CAL_SVC_2M(TFN_REF_OVR, tskid, pk_rovr);
}

Inline ER
stp_ovr(ID tskid)
{
	return (ER)CAL_SVC_1(TFN_STP_OVR, tskid);
}

Inline ER
sta_ovr(ID tskid, OVRTIM ovrtim)
{
	return (ER)CAL_SVC_2(TFN_STA_OVR, tskid, ovrtim);
}

Inline ER
ref_alm(ID almid, T_RALM *pk_ralm)
{
	return (ER)CAL_SVC_2M(TFN_REF_ALM, almid, pk_ralm);
}

Inline ER
stp_alm(ID almid)
{
	return (ER)CAL_SVC_1(TFN_STP_ALM, almid);
}

Inline ER
sta_alm(ID almid, RELTIM almtim)
{
	return (ER)CAL_SVC_2(TFN_STA_ALM, almid, almtim);
}

Inline ER
ref_mtx(ID mtxid, T_RMTX *pk_rmtx)
{
	return (ER)CAL_SVC_2M(TFN_REF_MTX, mtxid, pk_rmtx);
}

Inline ER
tloc_mtx(ID mtxid, TMO tmout)
{
	return (ER)CAL_SVC_2(TFN_TLOC_MTX, mtxid, tmout);
}

Inline ER
ploc_mtx(ID mtxid)
{
	return (ER)CAL_SVC_1(TFN_PLOC_MTX, mtxid);
}

Inline ER
loc_mtx(ID mtxid)
{
	return (ER)CAL_SVC_1(TFN_LOC_MTX, mtxid);
}

Inline ER
unl_mtx(ID mtxid)
{
	return (ER)CAL_SVC_1(TFN_UNL_MTX, mtxid);
}

Inline ER
istp_alm(ID almid)
{
	return (ER)CAL_SVC_1(TFN_ISTP_ALM, almid);
}

Inline ER
ista_alm(ID almid, RELTIM almtim)
{
	return (ER)CAL_SVC_2(TFN_ISTA_ALM, almid, almtim);
}

Inline ER
isig_tim(void)
{
	return (ER)CAL_SVC_0(TFN_ISIG_TIM);
}

Inline ER
iunl_cpu(void)
{
	return (ER)CAL_SVC_0(TFN_IUNL_CPU);
}

Inline ER
iloc_cpu(void)
{
	return (ER)CAL_SVC_0(TFN_ILOC_CPU);
}

Inline ER
iget_tid(ID *p_tskid)
{
	return (ER)CAL_SVC_1M(TFN_IGET_TID, p_tskid);
}

Inline ER
irot_rdq(PRI tskpri)
{
	return (ER)CAL_SVC_1(TFN_IROT_RDQ, tskpri);
}

Inline ER
ifsnd_dtq(ID dtqid, VP_INT data)
{
	return (ER)CAL_SVC_2(TFN_IFSND_DTQ, dtqid, data);
}

Inline ER
ipsnd_dtq(ID dtqid, VP_INT data)
{
	return (ER)CAL_SVC_2(TFN_IPSND_DTQ, dtqid, data);
}

Inline ER
iset_flg(ID flgid, FLGPTN setptn)
{
	return (ER)CAL_SVC_2(TFN_ISET_FLG, flgid, setptn);
}

Inline ER
isig_sem(ID semid)
{
	return (ER)CAL_SVC_1(TFN_ISIG_SEM, semid);
}

Inline ER
iras_tex(ID tskid, TEXPTN rasptn)
{
	return (ER)CAL_SVC_2(TFN_IRAS_TEX, tskid, rasptn);
}

Inline ER
irel_wai(ID tskid)
{
	return (ER)CAL_SVC_1(TFN_IREL_WAI, tskid);
}

Inline ER
iwup_tsk(ID tskid)
{
	return (ER)CAL_SVC_1(TFN_IWUP_TSK, tskid);
}

Inline ER
iact_tsk(ID tskid)
{
	return (ER)CAL_SVC_1(TFN_IACT_TSK, tskid);
}

Inline ER
get_ipm(PRI *p_intpri)
{
	return (ER)CAL_SVC_1M(TFN_GET_IPM, p_intpri);
}

Inline ER
chg_ipm(PRI intpri)
{
	return (ER)CAL_SVC_1(TFN_CHG_IPM, intpri);
}

Inline ER
ena_int(INTNO intno)
{
	return (ER)CAL_SVC_1(TFN_ENA_INT, intno);
}

Inline ER
dis_int(INTNO intno)
{
	return (ER)CAL_SVC_1(TFN_DIS_INT, intno);
}

Inline BOOL
sns_dpn(void)
{
	return (BOOL)CAL_SVC_0(TFN_SNS_DPN);
}

Inline BOOL
sns_dsp(void)
{
	return (BOOL)CAL_SVC_0(TFN_SNS_DSP);
}

Inline BOOL
sns_loc(void)
{
	return (BOOL)CAL_SVC_0(TFN_SNS_LOC);
}

Inline BOOL
sns_ctx(void)
{
	return (BOOL)CAL_SVC_0(TFN_SNS_CTX);
}

Inline ER
ena_dsp(void)
{
	return (ER)CAL_SVC_0(TFN_ENA_DSP);
}

Inline ER
dis_dsp(void)
{
	return (ER)CAL_SVC_0(TFN_DIS_DSP);
}

Inline ER
unl_cpu(void)
{
	return (ER)CAL_SVC_0(TFN_UNL_CPU);
}

Inline ER
loc_cpu(void)
{
	return (ER)CAL_SVC_0(TFN_LOC_CPU);
}

Inline ER
get_did(ID *p_domid)
{
	return (ER)CAL_SVC_1M(TFN_GET_DID, p_domid);
}

Inline ER
get_tid(ID *p_tskid)
{
	return (ER)CAL_SVC_1M(TFN_GET_TID, p_tskid);
}

Inline ER
rot_rdq(PRI tskpri)
{
	return (ER)CAL_SVC_1(TFN_ROT_RDQ, tskpri);
}

Inline ER
ref_cyc(ID cycid, T_RCYC *pk_rcyc)
{
	return (ER)CAL_SVC_2M(TFN_REF_CYC, cycid, pk_rcyc);
}

Inline ER
stp_cyc(ID cycid)
{
	return (ER)CAL_SVC_1(TFN_STP_CYC, cycid);
}

Inline ER
sta_cyc(ID cycid)
{
	return (ER)CAL_SVC_1(TFN_STA_CYC, cycid);
}

Inline ER
get_tim(SYSTIM *p_systim)
{
	return (ER)CAL_SVC_1M(TFN_GET_TIM, p_systim);
}

Inline ER
set_tim(const SYSTIM *p_systim)
{
	return (ER)CAL_SVC_1(TFN_SET_TIM, p_systim);
}

Inline ER
ref_mpf(ID mpfid, T_RMPF *pk_rmpf)
{
	return (ER)CAL_SVC_2M(TFN_REF_MPF, mpfid, pk_rmpf);
}

Inline ER
tget_mpf(ID mpfid, VP *p_blk, TMO tmout)
{
	return (ER)CAL_SVC_3M(TFN_TGET_MPF, mpfid, p_blk, tmout);
}

Inline ER
pget_mpf(ID mpfid, VP *p_blk)
{
	return (ER)CAL_SVC_2M(TFN_PGET_MPF, mpfid, p_blk);
}

Inline ER
get_mpf(ID mpfid, VP *p_blk)
{
	return (ER)CAL_SVC_2M(TFN_GET_MPF, mpfid, p_blk);
}

Inline ER
rel_mpf(ID mpfid, VP blk)
{
	return (ER)CAL_SVC_2(TFN_REL_MPF, mpfid, blk);
}

Inline ER
ref_mbx(ID mbxid, T_RMBX *pk_rmbx)
{
	return (ER)CAL_SVC_2M(TFN_REF_MBX, mbxid, pk_rmbx);
}

Inline ER
trcv_mbx(ID mbxid, T_MSG **ppk_msg, TMO tmout)
{
	return (ER)CAL_SVC_3M(TFN_TRCV_MBX, mbxid, ppk_msg, tmout);
}

Inline ER
prcv_mbx(ID mbxid, T_MSG **ppk_msg)
{
	return (ER)CAL_SVC_2M(TFN_PRCV_MBX, mbxid, ppk_msg);
}

Inline ER
rcv_mbx(ID mbxid, T_MSG **ppk_msg)
{
	return (ER)CAL_SVC_2M(TFN_RCV_MBX, mbxid, ppk_msg);
}

Inline ER
snd_mbx(ID mbxid, T_MSG *pk_msg)
{
	return (ER)CAL_SVC_2(TFN_SND_MBX, mbxid, pk_msg);
}

Inline ER
ref_dtq(ID dtqid, T_RDTQ *pk_rdtq)
{
	return (ER)CAL_SVC_2M(TFN_REF_DTQ, dtqid, pk_rdtq);
}

Inline ER
trcv_dtq(ID dtqid, VP_INT *p_data, TMO tmout)
{
	return (ER)CAL_SVC_3M(TFN_TRCV_DTQ, dtqid, p_data, tmout);
}

Inline ER
prcv_dtq(ID dtqid, VP_INT *p_data)
{
	return (ER)CAL_SVC_2M(TFN_PRCV_DTQ, dtqid, p_data);
}

Inline ER
rcv_dtq(ID dtqid, VP_INT *p_data)
{
	return (ER)CAL_SVC_2M(TFN_RCV_DTQ, dtqid, p_data);
}

Inline ER
fsnd_dtq(ID dtqid, VP_INT data)
{
	return (ER)CAL_SVC_2(TFN_FSND_DTQ, dtqid, data);
}

Inline ER
tsnd_dtq(ID dtqid, VP_INT data, TMO tmout)
{
	return (ER)CAL_SVC_3(TFN_TSND_DTQ, dtqid, data, tmout);
}

Inline ER
psnd_dtq(ID dtqid, VP_INT data)
{
	return (ER)CAL_SVC_2(TFN_PSND_DTQ, dtqid, data);
}

Inline ER
snd_dtq(ID dtqid, VP_INT data)
{
	return (ER)CAL_SVC_2(TFN_SND_DTQ, dtqid, data);
}

Inline ER
ref_flg(ID flgid, T_RFLG *pk_rflg)
{
	return (ER)CAL_SVC_2M(TFN_REF_FLG, flgid, pk_rflg);
}

Inline ER
twai_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn, TMO tmout)
{
	return (ER)CAL_SVC_5M(TFN_TWAI_FLG, flgid, waiptn, wfmode, p_flgptn, tmout);
}

Inline ER
pol_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn)
{
	return (ER)CAL_SVC_4M(TFN_POL_FLG, flgid, waiptn, wfmode, p_flgptn);
}

Inline ER
wai_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn)
{
	return (ER)CAL_SVC_4M(TFN_WAI_FLG, flgid, waiptn, wfmode, p_flgptn);
}

Inline ER
clr_flg(ID flgid, FLGPTN clrptn)
{
	return (ER)CAL_SVC_2(TFN_CLR_FLG, flgid, clrptn);
}

Inline ER
set_flg(ID flgid, FLGPTN setptn)
{
	return (ER)CAL_SVC_2(TFN_SET_FLG, flgid, setptn);
}

Inline ER
ref_sem(ID semid, T_RSEM *pk_rsem)
{
	return (ER)CAL_SVC_2M(TFN_REF_SEM, semid, pk_rsem);
}

Inline ER
twai_sem(ID semid, TMO tmout)
{
	return (ER)CAL_SVC_2(TFN_TWAI_SEM, semid, tmout);
}

Inline ER
pol_sem(ID semid)
{
	return (ER)CAL_SVC_1(TFN_POL_SEM, semid);
}

Inline ER
wai_sem(ID semid)
{
	return (ER)CAL_SVC_1(TFN_WAI_SEM, semid);
}

Inline ER
sig_sem(ID semid)
{
	return (ER)CAL_SVC_1(TFN_SIG_SEM, semid);
}

Inline ER
ref_tex(ID tskid, T_RTEX *pk_rtex)
{
	return (ER)CAL_SVC_2M(TFN_REF_TEX, tskid, pk_rtex);
}

Inline BOOL
sns_tex(void)
{
	return (BOOL)CAL_SVC_0(TFN_SNS_TEX);
}

Inline ER
ena_tex(void)
{
	return (ER)CAL_SVC_0(TFN_ENA_TEX);
}

Inline ER
dis_tex(void)
{
	return (ER)CAL_SVC_0(TFN_DIS_TEX);
}

Inline ER
ras_tex(ID tskid, TEXPTN rasptn)
{
	return (ER)CAL_SVC_2(TFN_RAS_TEX, tskid, rasptn);
}

Inline ER
dly_tsk(RELTIM dlytim)
{
	return (ER)CAL_SVC_1(TFN_DLY_TSK, dlytim);
}

Inline ER
frsm_tsk(ID tskid)
{
	return (ER)CAL_SVC_1(TFN_FRSM_TSK, tskid);
}

Inline ER
rsm_tsk(ID tskid)
{
	return (ER)CAL_SVC_1(TFN_RSM_TSK, tskid);
}

Inline ER
sus_tsk(ID tskid)
{
	return (ER)CAL_SVC_1(TFN_SUS_TSK, tskid);
}

Inline ER
rel_wai(ID tskid)
{
	return (ER)CAL_SVC_1(TFN_REL_WAI, tskid);
}

Inline ER_UINT
can_wup(ID tskid)
{
	return (ER_UINT)CAL_SVC_1(TFN_CAN_WUP, tskid);
}

Inline ER
wup_tsk(ID tskid)
{
	return (ER)CAL_SVC_1(TFN_WUP_TSK, tskid);
}

Inline ER
tslp_tsk(TMO tmout)
{
	return (ER)CAL_SVC_1(TFN_TSLP_TSK, tmout);
}

Inline ER
slp_tsk(void)
{
	return (ER)CAL_SVC_0(TFN_SLP_TSK);
}

Inline ER
ref_tsk(ID tskid, T_RTSK *pk_rtsk)
{
	return (ER)CAL_SVC_2M(TFN_REF_TSK, tskid, pk_rtsk);
}

Inline ER
get_pri(ID tskid, PRI *p_tskpri)
{
	return (ER)CAL_SVC_2M(TFN_GET_PRI, tskid, p_tskpri);
}

Inline ER
chg_pri(ID tskid, PRI tskpri)
{
	return (ER)CAL_SVC_2(TFN_CHG_PRI, tskid, tskpri);
}

Inline ER
ter_tsk(ID tskid)
{
	return (ER)CAL_SVC_1(TFN_TER_TSK, tskid);
}

Inline ER
ext_tsk(void)
{
	return (ER)CAL_SVC_0(TFN_EXT_TSK);
}

Inline ER_UINT
can_act(ID tskid)
{
	return (ER_UINT)CAL_SVC_1(TFN_CAN_ACT, tskid);
}

Inline ER
act_tsk(ID tskid)
{
	return (ER)CAL_SVC_1(TFN_ACT_TSK, tskid);
}

#else /* !defined(__GNUC__) && !defined(__ghs__) */
#error Compiler not supported
#endif /* defined(__GNUC__) */

#endif /* _MACRO_ONLY */
#endif /* CALSVC_TRAP */
#endif /* _KERNEL_SVC_H_ */
