/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001,2002 by Information-technology Promotion Agency, JAPAN
 *  Copyright (C) 2001,2002 by TRON Association, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ݸɥᥤ⥸塼
 */

#ifndef _DOMAIN_H_
#define _DOMAIN_H_

/*
 *  ݸɥᥤ°ʥͥѤ
 */
#define TA_KERNEL		0x00u		/* ͥɥᥤ */
#define TA_USER			0x01u		/* 桼ɥᥤ */

/*
 *  ĥѥɽ
 */
#define TACPTN_SHARED	(~0u)			/* ٤ƤΥɥᥤ󤫤饢 */
#define TACPTN_KERNEL	(1u << 31)		/* ͥɥᥤΤߥ */
#define TACPTN(acptn)	((acptn) | TACPTN_KERNEL)

#ifndef _MACRO_ONLY

/*
 *  ݸɥᥤ֥å
 */
typedef struct domain_initialization_block {
	ATR		domatr;			/* ݸɥᥤ° */
	ACPTN	domptn;			/* ݸɥᥤΥӥåȥѥ */
	DOMCTXB	domctxb;		/* ݸɥᥤ󥳥ƥȥ֥å */
} DOMINIB;

/*
 *  ݸɥᥤIDκ͡kernel_cfg.c
 */
extern const ID	tmax_domid;

/*
 *  ݸɥᥤ֥åΥꥢkernel_cfg.c
 */
extern const DOMINIB	dominib_table[];

/*
 *  ͥɥᥤݸɥᥤ֥å
 */
extern const DOMINIB	dominib_kernel;

/*
 *  ֥°°ݸɥᥤIDФΥޥ
 *
 *  ΥޥϡATR32ӥåȤǤ뤳ȤꤷƤ롥Ǥ
 *  ˤϡåȰ¸Ǥ񤭤ʤФʤʤ
 */
#ifndef OBJ_DOMID
#define OBJ_DOMID(objatr)	((ID)((H)((objatr) >> 16)))
#endif /* OBJ_DOMID */

/*
 *  桼ݸɥᥤݸɥᥤIDݸɥᥤ֥å
 *  򥤥ǥå뤿Υޥ
 */
#define INDEX_DOM(domid)	((UINT)((domid) - TMIN_DOMID))

#endif /* _MACRO_ONLY */
#endif /* _DOMAIN_H_ */
