/*
 *  IIMP Kernel
 *      An Implementation of ITRON with Memory Protection
 * 
 *  Copyright (C) 2001,2002 by Information-technology Promotion Agency, JAPAN
 *  Copyright (C) 2001,2002 by TRON Association, JAPAN
 * 
 *  based on TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  (1)(4)ξ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 */


/* 
 *  ץץ(1)Υإåե
 */

#define LOOP_REF	1000000		/* ®ٷ¬ѤΥ롼ײ */

#define MAIN_PRIORITY	5		/* ᥤ󥿥ͥ */
								/* HIGH_PRIORITY ⤯뤳 */

#define HIGH_PRIORITY	9		/* ˼¹Ԥ륿ͥ */
#define MID_PRIORITY	10
#define LOW_PRIORITY	11

#define	STACK_SIZE	8192		/* Υå */

/* 
 *  CPU㳰ϥɥεư*/
#ifdef M68K

#define CPUEXC1		5		/* 㳰 */
#define RAISE_CPU_EXCEPTION	syslog(LOG_NOTICE, "zerodiv = %d", 10 / 0)

#elif defined(SH3)

//#define CPUEXC1		224		/* ɥ顼㳰 */
#define CPUEXC1			384		/*	0x180		 ɥ顼㳰 */
#define RAISE_CPU_EXCEPTION	(*((volatile int *) 0xFFFFFEC1))

#elif defined(SH1)

#elif defined(ARM7TDMI)

#elif defined(V850)

#elif defined(I386)

#elif defined(LINUX)

#define CPUEXC1		8		/* 㳰 */
#define RAISE_CPU_EXCEPTION	syslog(LOG_NOTICE, "zerodiv = %d", 10 / 0)
#define OMIT_VGET_TIM

#endif
#ifdef MIPS32
#define TOKKEN_TST() Asm("mfc0 $0, $0")
#endif


/* 
 *  ִ
 */

#define		T_OK					-1001
#define		T_SUCCESS				-1002
#define		T_END					-1003
#define		T_LINE					-1004


#define		C_EQ					0	/* src == dst */
#define		C_NE					1	/* src != dst */
#define		C_LT					2	/* src < dst */
#define		C_LE					3	/* src <= dst */
#define		C_GT					4	/* src > dst */
#define		C_GE					5	/* src >= dst */


/* message for mbx */
typedef	struct	msg_data{
	T_MSG	h;
	INT		msg;
} MSG_DATA;

/* task start para. */
typedef	struct	act_menu{
	INT		menu;

#define	F_NOTHING	0
#define	F_ACT_TSK	1
#define	F_CAN_ACT	3
#define	F_SLP_TSK	4
#define	F_WUP_TSK	5
#define	F_CAN_WUP	6
#define	F_GET_PRI	7
#define	F_CHG_PRI	8
#define	F_REL_WAI	9
#define	F_SUS_TSK	10
#define	F_RSM_TSK	11
#define	F_FRSM_TSK	12
#define	F_TER_TSK	13

#define	F_WAI_SEM	14
#define	F_POL_SEM	15
#define	F_TWAI_SEM	16
#define	F_SIG_SEM	17

#define	F_SET_FLG	18
#define	F_CLR_FLG	19
#define	F_WAI_FLG	20
#define	F_POL_FLG	21
#define	F_TWAI_FLG	22

#define	F_SND_DTQ	23
#define	F_PSND_DTQ	24
#define	F_TSND_DTQ	25
#define	F_FSND_DTQ	26
#define	F_RCV_DTQ	27
#define	F_PRCV_DTQ	28
#define	F_TRCV_DTQ	29

#define	F_SND_MBX	30
#define	F_RCV_MBX	31
#define	F_PRCV_MBX	32
#define	F_TRCV_MBX	33

#define	F_GET_MPF	34
#define	F_PGET_MPF	35
#define	F_TGET_MPF	36
#define	F_REL_MPF	37

#define	F_SND_MBP	38
#define	F_RCV_MBP	39
#define	F_PRCV_MBP	40
#define	F_TRCV_MBP	41

#define	F_GET_MPP	42
#define	F_PGET_MPP	43
#define	F_TGET_MPP	44
#define	F_REL_MPP	45

#define	F_XXX_TEX	46

#define	F_GET_DID	47

#define	F_VPRB_MEM	90

#define	F_CPU_COMMAND	99


	ID		id;
	VP_INT	p2;
	INT		reftsk;
	INT		er;
	B		msg_buf[64];

	VP_INT	data;
	PRI		pri;
	TMO		tmout;
	FLGPTN	ptn;
	FLGPTN	pptn;
	VP_INT	pdata;
	T_MSG	*msg;
	T_MSG	*pmsg;
	VP		blk;
	UINT	size;
	MODE	mode;

} ACT_MENU;

/*--- function(function.c)*/
extern	void	privileged_instructions();
extern	void	exec_svc(VP_INT code);
extern	INT	ref_tsk( ID tskid );
extern	INT	get_tsk_result( ID tskid );
extern	void	ref_tsk_event( ID tskid, INT d );
extern	void	ref_tsk_init();
extern	void	t_pline	(char *msg);
extern	void	rint2sz(char *str, int num, int *off);
extern	void	int2sz(char *str, int num);
extern	char	*str_plus( B *buf, B *s1 );
extern	void	chg_buf	(char *no, char *comment, int code,  char *buf);
extern	void	t_success( B *no, B *comment, ID t_id, ER ec);
extern	BOOL	t_error( B *no, ID t_id, ER src, INT cmp, ER dst);

extern	void	test_1_1_1();
extern	void	test_1_1_2();
extern	void	test_1_1_3();

extern	void	test_2_1_1();
extern	void	test_2_1_2();
extern	void	test_2_1_3();
extern	void	test_2_1_4();
extern	void	test_2_1_5();
extern	void	test_2_1_6();
extern	void	test_2_1_7();

extern	void	test_2_2_1();
extern	void	test_2_3_1();
extern	void	test_2_3_2();

extern	void	test_3_2_1();
extern	void	test_3_2_2();

extern	void	test_3_3_1();

extern	void	test_3_4_1();
extern	void	test_3_4_2();

extern	void	test_4_2_1();
extern	void	test_4_2_2();

extern	void	test_4_3_1();
extern	void	test_4_3_2();
extern	void	test_4_3_3();

extern	void	test_4_4_1();
extern	void	test_4_4_2();
extern	void	test_4_4_3();

extern	void	test_4_5_1();
extern	void	test_4_5_2();
extern	void	test_4_5_3();

extern	void	test_4_6_1();
extern	void	test_4_6_2();
extern	void	test_4_6_3();

extern	void	test_4_7_1();
extern	void	test_4_7_2();
extern	void	test_4_7_3();

extern	void	test_4_8_1();

extern	void	test_5_1_1();
extern	void	test_5_2_1();

extern	void	test_6_1_1();

extern	void	test_6_3_1();
extern	void	test_6_3_2();
extern	void	test_6_3_3();
extern	void	test_6_3_4();
extern	void	test_6_3_5();

extern	void	test_6_5_1();
extern	void	test_6_5_2();
extern	void	test_6_5_3();
extern	void	test_6_5_4();
extern	void	test_6_5_5();
extern	void	test_6_5_6();
extern	void	test_6_6_1();
extern	void	test_6_6_2();
extern	void	test_6_6_3();
extern	void	test_6_6_4();
extern	void	test_6_6_5();
extern	void	test_6_6_6();
extern	void	test_6_6_7();
extern	void	test_6_6_8();
extern	void	test_6_7_1();
extern	void	test_6_7_2();
extern	void	test_6_7_3();
extern	void	test_6_7_4();
extern	void	test_6_7_5();
extern	void	test_6_7_6();
extern	void	test_6_7_7();
extern	void	test_6_7_8();
extern	void	test_6_7_9();
extern	void	test_6_7_10();		/* 02/02/18	yu`		*/
extern	void	test_6_7_11();		/* 02/02/18	yu`		*/

extern	void	test_6_8_1();
extern	void	test_6_8_2();
extern	void	test_6_8_3();

extern	void	test_7_2_1();
extern	void	test_7_2_2();

extern	void	test_7_4_1();
extern	void	test_7_4_2();
extern	void	test_7_4_3();
extern	void	test_7_4_4();
extern	void	test_7_4_5();
extern	void	test_7_4_6();
extern	void	test_7_4_7();
extern	void	test_7_4_8();

extern	void	test_7_5_1();
extern	void	test_7_5_2();
extern	void	test_7_5_3();
extern	void	test_7_5_4();
extern	void	test_7_5_5();
extern	void	test_7_5_6();
extern	void	test_7_5_7();

extern	void	test_7_6_1();
extern	void	test_7_6_2();
extern	void	test_7_6_3();
extern	void	test_7_6_4();
extern	void	test_7_6_5();
extern	void	test_7_6_6();
extern	void	test_7_6_7();
extern	void	test_7_6_8();
extern	void	test_7_6_9();
extern	void	test_7_6_10();
extern	void	test_7_6_11();		/* 02/02/18	yu`		*/

extern	void	test_7_8_1();
extern	void	test_7_8_2();
extern	void	test_7_8_3();
extern	void	test_7_8_4();
extern	void	test_7_8_5();

extern	void	test_7_9_1();
extern	void	test_7_9_2();
extern	void	test_7_9_3();

extern	void	test_8_1_1();
extern	void	test_8_2_1();


/* 02/02/18	yu`		*/

#define TFN_PROBE_MEMORY	(9)

extern	ER SVC_probe_memory(VP base, SIZE size, ID domid, ID tskid, MODE pmmode);


/*--- DOM1(sample1.c)*/
extern	INT	dom1_mem;
extern	void	task1(VP_INT code);
extern	void	task2(VP_INT code);
extern	void	main_task(VP_INT exinf);
extern	void	dom1_cyc(VP_INT exinf);
extern	void	dom1_tex(TEXPTN texptn, VP_INT exinf);
extern	void	task2_tex(TEXPTN texptn, VP_INT exinf);			/* Add	02/02/18-2	*/

/*--- DOM2(sample2.c)*/
extern	INT	dom2_mem;
extern	void	task3(VP_INT code);
extern	void	dom2_cyc(VP_INT exinf);
extern	void	dom2_tex(TEXPTN texptn, VP_INT exinf);

/*--- DOM3(sample3.c)*/
extern	INT	dom3_mem;
extern	void	task4(VP_INT code);
extern	void	dom3_cyc(VP_INT exinf);

/*--- Kernel DOM(sample.c)*/
extern	void	kernel_tex(TEXPTN texptn, VP_INT exinf);
extern	void	task99(VP_INT code);
extern	void	tex_routine(TEXPTN texptn, VP_INT tskno);
extern	void	cyclic_handler(VP_INT exinf);
extern	void	cpuexc_handler(VP p_excinf);
extern	void	mav_handler(VP p_excinf);
extern	void	debug_task(VP_INT exinf);

/*--- shared(shared.c)*/
extern	void	shared_cyc(VP_INT exinf);
extern	BOOL	pi_flag;
extern	ACT_MENU	stac[];
extern	MSG_DATA	mdata[];

extern	volatile	INT		cyc_count_dom1;
extern	volatile	INT		cyc_count_dom2;
extern	volatile	INT		cyc_count_dom3;
extern	volatile	INT		cyc_count_shared;

/*-- for SH3  */
extern	volatile	INT		test_2_1_3_flg;
extern	void		task3_exit(VP_INT exinf);

/*	Please Change Value	By ELMIC		*/
/* for ATT_MEM */

#define		MEM_SIZE	0x00100		/* Size		*/

#define		IDP_ADDR_RW	(RW_BASE + 0x00040000)		/* RW Address			*/
#define		DOM1_ADDR_RW	(RW_BASE + 0x00042000)	/* Domain 1 RW Address	*/
#define		DOM2_ADDR_RW	(RW_BASE + 0x00044000)	/* Domain 2 RW Address	*/
#define		DOM3_ADDR_RW	(RW_BASE + 0x00046000)	/* Domain 3 RW Address	*/
#define		KNL_ADDR_RW	(RW_BASE + 0x00048000)	/* Kernel Domain RW Address	*/

#define		IDP_ADDR_RO	(RW_BASE + 0x00050000)		/* RO Address			*/
#define		DOM1_ADDR_RO	(RW_BASE + 0x00052000)	/* Domain 1 RO Address	*/
#define		DOM2_ADDR_RO	(RW_BASE + 0x00054000)	/* Domain 2 RO Address	*/
#define		DOM3_ADDR_RO	(RW_BASE + 0x00056000)	/* Domain 3 RO Address	*/
#define		KNL_ADDR_RO	(RW_BASE + 0x00058000)	/* Kernel Domain RO Address	*/
