/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2005-2010 by Monami Software Limited Partnership, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

#ifndef _BOARD_SERIAL_H_
#define _BOARD_SERIAL_H_

#define BOARD_SERIAL

/*
 *  ǥХ˶뤵륯å
 */
/* ꥢ˶뤵륯åȿ [Hz]ʥܡ졼ǻѡ */
#define XIN_CLOCK	3686400

/*
 *  ǥХγߥޥ
 *
 *  ͥ : () ꥢ룱 == ꥢ룰 -> ޣ ()
 */

/*
 *  ꥢ룰ߤγߥޥѡ
 *  ߥ٥Ʊ٥ꤷƤ
 */
#define CORE_IPM_SCC		INIT_CORE_IPM	/* MIPS32(SR)ѥǡ */

#define ICU_IPM_UART0		MAX_ICU_ILV

/*  ꤹߥޥIPMǵҤ */
#define IPM_SCC0	{ CORE_IPM_SCC, {ICU_IPM_UART0} }

/*
 *  ꥢ룱ߤγߥޥѡ
 *  ߥ٥Ʊ٥ꤷƤ
 *  MIPS32ѤΥǡϡSCC0ȶ
 */
#define ICU_IPM_UART1		3u

/*  ꤹߥޥIPMǵҤ */
#define IPM_SCC1	{ CORE_IPM_SCC, {ICU_IPM_UART1} }

#endif /* _BOARD_SERIAL_H_ */
