/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2005-2010 by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2005-2006 by Japan Aerospace Exploration Agency.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		åȥƥ˰¸JAXA_MIPS_TENGINEѡ
 *
 *  Υ󥯥롼ɥեϡkernel.hsil.hǥ󥯥롼ɤ롥
 *  ¾Υե뤫ľܥ󥯥롼ɤ뤳ȤϤʤΥե򥤥
 *  롼ɤˡt_stddef.hitron.h󥯥롼ɤΤǡ
 *  ˰¸Ƥ褤
 */

#ifndef _SYS_DEFS_H_
#define _SYS_DEFS_H_

#define JAXA_MIPS_TENGINE			/* ƥά */

/*
 *  ƥå
 */
#define	TIC_NUME	1u		/* ƥåμʬ */
#define	TIC_DENO	1u		/* ƥåμʬ */

/*
 *  μԻμ¹ǽ
 */
#ifndef _MACRO_ONLY
#ifdef DEBUG_EJTAG			/* EJTAG Debug Mode */

Inline void
_assert_abort(void)
{
	Asm("sdbbp");
}

#else /* DEBUG_EJTAG */		/* ¾γȯĶ */

extern void		_assert_abort(void);

#endif /* DEBUG_EJTAG */
#endif /* _MACRO_ONLY */

/*
 *  ͥ٤ϰ
 */
#define TMIN_INTPRI		(-1)		/* ͥ٤κǾ */
#define TMAX_INTPRI		(-1)		/* ͥ٤κ */

/*
 *  ץåΥǥ
 */
#define	SIL_ENDIAN	SIL_ENDIAN_LITTLE	/* ȥ륨ǥ */

#endif /* _SYS_DEFS_H_ */
