/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2005-     by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2005-2006 by Japan Aerospace Exploration Agency.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ͥѤΥȥåץ⥸塼MIPS32ѡ
 */

#define	_MACRO_ONLY
#include "hrp_kernel.h"
#define dmfc0 mfc0
#define dmtc0 mtc0
#define sd sw

	.set at
	.set reorder

	.section .text_reset, "ax"
	.align 2

/*
 *   MIPS32ѥȥåץ⥸塼
 *   
 *   ͥϥץꥱȥ󥯤ƻѤʤΤ
 *   ͥΤ߻Ѥ롣
 */

	.global	reset

reset:
	/*
	 *  CPU쥸ν
	 */

	/* HI, LO (쥸) */
	mthi	zero
	mtlo	zero

	/* gp (Хݥ)
	     _gp ϡƥ¸(󥫥ץȿ侩) */
	ABI_PLA	gp, _gp

	/*
	 *  CP0쥸ν
	 */

	/* WatchLo (åLo쥸) */
	mfc0 a4, Config, 1
	andi a4, a4, Config1_WR
	beq a4, zero, reset_1
	li a5, ~(WatchLo_I | WatchLo_R | WatchLo_W)
	li a6, WatchHi_M
	dmfc0 a4, WatchLo, 0
	and a4, a4, a5
	dmtc0 a4, WatchLo, 0
	mfc0 a4, WatchHi, 0
	and a4, a4, a6
	beq a4, zero, reset_0
	dmfc0 a4, WatchLo, 1
	and a4, a4, a5
	dmtc0 a4, WatchLo, 1
	mfc0 a4, WatchHi, 1
	and a4, a4, a6
	beq a4, zero, reset_0
	dmfc0 a4, WatchLo, 2
	and a4, a4, a5
	dmtc0 a4, WatchLo, 2
	mfc0 a4, WatchHi, 2
	and a4, a4, a6
	beq a4, zero, reset_0
	dmfc0 a4, WatchLo, 3
	and a4, a4, a5
	dmtc0 a4, WatchLo, 3
	mfc0 a4, WatchHi, 3
	and a4, a4, a6
	beq a4, zero, reset_0
	dmfc0 a4, WatchLo, 4
	and a4, a4, a5
	dmtc0 a4, WatchLo, 4
	mfc0 a4, WatchHi, 4
	and a4, a4, a6
	beq a4, zero, reset_0
	dmfc0 a4, WatchLo, 5
	and a4, a4, a5
	dmtc0 a4, WatchLo, 5
	mfc0 a4, WatchHi, 5
	and a4, a4, a6
	beq a4, zero, reset_0
	dmfc0 a4, WatchLo, 6
	and a4, a4, a5
	dmtc0 a4, WatchLo, 6
	mfc0 a4, WatchHi, 6
	and a4, a4, a6
	beq a4, zero, reset_0
	dmfc0 a4, WatchLo, 7
	and a4, a4, a5
	dmtc0 a4, WatchLo, 7
reset_0:
	CLEAR_HAZARD_WATCHLO
reset_1:

	/* Cause (쥸) */
	mfc0 a4, Cause
	li a5, INIT_CAUSE_AND
	and a4, a4, a5
	li a5, INIT_CAUSE_OR
	or a4, a4, a5
	mtc0 a4, Cause
	CLEAR_HAZARD_CAUSE

	/* SR (ơ쥸)
	     (ǥγߥޥꤹ롣ϡ¼Ūʳϡ
	     ߥȥǹԤᡣ)
	     INIT_STATUS_AND  INIT_STATUS_OR ϡsys_config.h  */
	mfc0 a4, Status
	li a5, INIT_STATUS_AND
	and a4, a4, a5
	li a5, INIT_STATUS_OR
	or a4, a4, a5
	mtc0 a4, Status
	CLEAR_HAZARD_STATUS

	/* Config (ե쥸)
	     INIT_CONFIG_AND  INIT_CONFIG_OR ϡsys_config.h  */
	mfc0 a4, Config
	li a5, INIT_CONFIG_AND
	and a4, a4, a5
	li a5, INIT_CONFIG_OR
	or a4, a4, a5
	mtc0 a4, Config
	CLEAR_HAZARD_CONFIG

	/* Compare (ӥ쥸) */
	li	a4, 0xffffffff
	mtc0	a4, Compare

#if ABI_FPR == 0
#else /* ABI_FPR == 8 */
	li t4, INIT_FCSR
	ctc1 t4, $31
#endif

	/*
	 *  hardware_init_hook ƤӽФ(0Ǥʤ)
	 *
	 *  åȥϡɥ˰¸ϡ
	 *    hardware_init_hook ȤؿѰդ롥
	 *      ROMκݡRAMѲǽˤ뤿ΥХȥν
	 *    ϡsys_support.S  hardware_init_hook Ƥ롥
	 */
hardware_init:
	ABI_PLA	a4, hardware_init_hook
	beq	a4, zero, bss_clear
	jalr	ra, a4

	/*
         * bss򥯥ꥢ
	 */
	/*
	 *  CAUTION: useg is not available.
	 */
bss_clear:
	ABI_PLA	a5, _sbss_unmapped
	ABI_PLA	a6, _ebss_unmapped
	beq	a5, a6, data_sec_copy
loop_bss_clear:
	ABI_PADDIU a5, a5, 1
	sltu a7, a5, a6
	sb zero, -1(a5)
	bne a7, zero, loop_bss_clear

	/*
	 *  data (ROMб)
	 *
	 *  _sidata_unmapped  _eidata_unmapped ޤǤ_sdata_unmapped ʹߤ˥ԡ
	 */
	/*
	 *  CAUTION: useg is not available.
	 */
data_sec_copy:
	ABI_PLA	a5, _sidata_unmapped
	ABI_PLA	a6, _eidata_unmapped
	beq	a5, a6, reset_2
	ABI_PLA	a7, _sdata_unmapped
loop_data_sec_copy:
	lb	t5, (a5)
        sb	t5, (a7)
	ABI_PADDIU a5, a5, 1
	sltu t4, a5, a6
	ABI_PADDIU a7, a7, 1
	bne t4, zero, loop_data_sec_copy

reset_2:
	/* sp (åݥ󥿡󥿥ƥ) */
	ABI_PLA t8, istk
	ABI_PL t8, (t8)
	ABI_PLA t9, istksz
	ABI_PL t9, (t9)
	ABI_PADDU sp, t8, t9

	/* nontask_nest (/CPU㳰ͥȥ) */
	ABI_PLA t8, nontask_nest
	li t9, 1
	sd t9, (t8)		/* ưޤǤϡ󥿥ƥȤǤ
				   ¹ԤȤߤʤ */

#ifndef GENERATE_MEMINIB
#else /* GENERATE_MEMINIB */
	ABI_PLA v1, cpu_initialize_memory
	jalr v1
#endif /* GENERATE_MEMINIB */

	/*
         * bss򥯥ꥢ
	 */
	ABI_PLA v1, cpu_initialize_bss
	jalr v1

	/*
	 *  data (ROMб)
	 */
	ABI_PLA v1, cpu_initialize_data
	jalr v1

	/*
	 *  software_init_hook ƤӽФ0 Ǥʤ
	 *
	 *  եȥĶä˥饤֥ˤ˰¸ɬפʽ
	 *  ϡsoftware_init_hook ȤؿѰդ롥
	 */
software_init:
	ABI_PLA	a4, software_init_hook
	beq	a4, zero, start_kernel
	jalr	ra, a4

	/*
         *  ͥư
	 */
start_kernel:
	ABI_PLA	a4, sta_ker
	j	a4
