/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		顼ϥɥ鵡ǽ
 */

#ifndef _ALARM_H_
#define _ALARM_H_

#include "time_event.h"

/*
 *  顼ϥɥ֥å
 */
typedef struct alarm_handler_initialization_block {
	ATR		almatr;			/* 顼ϥɥ° */
	VP_INT	exinf;			/* 顼ϥɥγĥ */
	FP		almhdr;			/* 顼ϥɥεư */
	ACVCT	acvct;			/* ĥ٥ */
} ALMINIB;

/*
 *  顼ϥɥ֥å
 */
typedef struct alarm_handler_control_block {
	const ALMINIB *p_alminib;	/* ֥åؤΥݥ */
	BOOL	almsta;				/* 顼ϥɥư */
	TMEVTB	tmevtb;				/* ।٥ȥ֥å */
} ALMCB;

/*
 *  顼ϥɥIDκ͡kernel_cfg.c
 */
extern const ID	tmax_almid;

/*
 *  顼ϥɥ֥åΥꥢkernel_cfg.c
 */
extern const ALMINIB	alminib_table[];

/*
 *  顼ϥɥ֥åΥꥢkernel_cfg.c
 */
extern ALMCB	almcb_table[];

/*
 *  顼ϥɥ鵡ǽν
 */
extern void	initialize_alarm(void);

/*
 *  顼ϥɥ鵯ư롼
 */
extern void	call_almhdr(ALMCB *p_almcb);

#endif /* _ALARM_H_ */
