/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001,2002 by Information-technology Promotion Agency, JAPAN
 *  Copyright (C) 2001,2002 by TRON Association, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ꥪ֥ȴ⥸塼
 */

#ifndef _MEMORY_H_
#define _MEMORY_H_

/*
 *  °ʥͥѤ
 *
 *  HRPͥǼºݤ˻ȤƤΤϡTA_UNUSEDTA_USTACKΤߤǤ롥
 *  ¾3ĤϡͥǤ϶̤ưɬפʤ
 */
#define TA_UNUSED	0x0000		/* ̤ΰ */
#define TA_ATTMOD	0x0100		/* ATT_MODϿ줿ꥪ֥ */
#define TA_ATTMEM	0x0200		/* ATT_MEMϿ줿ꥪ֥ */
#define TA_USTACK	0x0400		/* Υ桼åΰ */
#define TA_MPF		0x0800		/* Ĺסΰ */

#ifndef _MACRO_ONLY

/*
 *  ꥪ֥Ƚ֥å
 *
 *  ̤ΰTA_UNUSEDˤФƤϡ٤ƤΥĥѥ
 *  acptn1acptn2acptn4ˤ0ˤ롥ޤ꡼ɥ꡼TA_RO
 *  ΰФƤϡ̾1ʽߥˤΥĥѥ
 *  acptn1ˤ0ˤ롥
 */
typedef struct memory_initialization_block {
	ATR		mematr;			/* ꥪ֥° */
	ACPTN	acptn4;			/* Υĥѥ */
	ACPTN	acptn1;			/* ̾1Υĥѥ󡿥TCB */
	ACPTN	acptn2;			/* ̾2Υĥѥ */
} MEMINIB;

#ifndef GENERATE_MEMINIB

/*
 *  ե졼ꥪ֥Ƚ֥å
 *
 *  ꥪ֥Ƚ֥åΥȥꥪ֥Ȥ
 *  ƬϤΰ衤ꥪ֥Ƚ֥åΰϡ⡤
 *  ե졼kernel_cfg.cΰȤ롥
 */

/*
 *  ꥪ֥Ƚ֥åΥȥkernel_cfg.c
 */
extern const UINT	tnum_meminib;

/*
 *  ꥪ֥ȤƬϤΰkernel_cfg.c
 *
 *  ǽΥȥʺǽΥꥪ֥ȤƬϡˤ0Ǥ뤳ȡ
 */
extern const VP		memtop_table[];

/*
 *  ꥪ֥Ƚ֥åΰkernel_cfg.c
 */
extern const MEMINIB	meminib_table[];

#else /* GENERATE_MEMINIB */

/*
 *  ͥ뤬ꥪ֥Ƚ֥å
 *
 *  ե졼ϡꥪ֥ȽΥȥȥ
 *  ꥪ֥Ƚΰkernel_cfg.cΰȤ
 *  롥ͥϡinitialize_memoryˤˤơ
 *  򸵤ˡꥪ֥Ƚ֥åΥȥꥪ
 *  ֥ȤƬϤΰ衤ꥪ֥Ƚ֥åΰ
 *  롥
 */

/*
 *  ꥪ֥Ƚ
 */
typedef struct memory_initialization_information {
	VP		top;			/* ꥪ֥ȤƬ */
	VP		limit;			/* ꥪ֥Ȥξϡʺǽ+1*/
	ATR		mematr;			/* ꥪ֥° */
	ACPTN	acptn4;			/* Υĥѥ */
	ACPTN	acptn1;			/* ̾1Υĥѥ󡿥TCB */
	ACPTN	acptn2;			/* ̾2Υĥѥ */
} MEMINFO;

/*
 *  ꥪ֥ȽΥȥkernel_cfg.c
 */
extern const UINT	tnum_meminfo;

/*
 *  ꥪ֥Ƚΰkernel_cfg.c
 */
extern const MEMINFO	meminfo_table[];

/*
 *  ꥪ֥Ƚ֥åΥȥkernel_cfg.c
 */
extern UINT		tnum_meminib;

/*
 *  ꥪ֥ȤƬϤΰkernel_cfg.c
 *
 *  ǽΥȥʺǽΥꥪ֥ȤƬϡˤ0Ǥ뤳ȡ
 */
extern VP		memtop_table[];

/*
 *  ꥪ֥Ƚ֥åΰkernel_cfg.c
 */
extern MEMINIB	meminib_table[];

#endif /* GENERATE_MEMINIB */

/*
 *  ꥪ֥ȴ⥸塼ν
 */
extern void	initialize_memory(void);

/*
 *  ؤν߸Υå
 */
extern BOOL	probe_mem_write(VP base, SIZE size);

/*
 *  ꤫ɽФΥå
 */
extern BOOL	probe_mem_read(VP base, SIZE size);

/*
 *  åΰ˴ޤޤƤ뤫Υå
 */
extern BOOL	probe_stack(VP base, SIZE size);

/*
 *  ͥΥꥢ뤿Υǡ
 *
 *  åΰȸĹסΰVPΥ礭ñ
 *  ̤ǥ饤󤵤ɬפˤϡ__STK_UNIT__MPF_UNIT򡤤
 *  줾쥢饤󤵤ñ̤Υǡ롥
 */
#ifndef __STK_UNIT
typedef VP	__STK_UNIT;
#endif /* __STK_UNIT */

#ifndef __MPF_UNIT
typedef VP	__MPF_UNIT;
#endif /* __MPF_UNIT */

/*
 *  ΥåΤΥޥ
 *
 *  ʲϡ饤Ȥñ̤2ζҾǤ뤳ȤꤷƤ롥
 */
#ifndef PROBE_MEM_WRITE
#define PROBE_MEM_WRITE(p_var, type) \
					(ALIGN_TYPE(p_var, type) \
						&& probe_mem_write((VP)(p_var), sizeof(*(p_var))))
#endif /* PROBE_MEM_WRITE */

#ifndef PROBE_MEM_READ
#define PROBE_MEM_READ(p_var, type) \
					(ALIGN_TYPE(p_var, type) \
						&& probe_mem_read((VP)(p_var), sizeof(*(p_var))))
#endif /* PROBE_MEM_READ */

/*
 *  åؤΥåΤΥޥ
 *
 *  ʲϡ__STK_UNITΥ2ζҾǤ뤳ȤꤷƤ롥
 */
#ifndef PROBE_STACK
#define PROBE_STACK(sp, size) \
			((((SIZE)(sp)) & (sizeof(__STK_UNIT) - 1u)) == 0u \
								&& probe_stack((sp), (size)))
#endif /* PROBE_STACK */

#endif /* _MACRO_ONLY */
#endif /* _MEMORY_H_ */
