#ifndef JSP_SERVICES_H
#define JSP_SERVICES_H

#include <kernel.h>
#include "target.h"
extern void	t_perror(UINT prio, const char *file, int line,
					const char *expr, ER ercd) throw();
Inline ER
_t_perror(const char *file, int line, const char *expr, ER ercd)
{
	if (ercd < 0) {
		t_perror(LOG_ERROR, file, line, expr, ercd);
	}
	return(ercd);
}
#define syscall(s)	_t_perror(__FILE__, __LINE__, #s, (s))
#ifndef CALSVC_TRAP
#undef ref_tsk
#endif
#define kernel_exit ext_ker
#define ref_tsk iimp_ref_tsk
#define vprb_mem prb_mem

#endif
