/*
 *  IIMP Kernel
 *      An Implementation of ITRON with Memory Protection
 * 
 *  Copyright (C) 2001,2002 by Information-technology Promotion Agency, JAPAN
 *  Copyright (C) 2001,2002 by TRON Association, JAPAN
 *
 *  IIMP Kernel
 *      An Implementation of ITRON with Memory Protection
 * 
 *  Copyright (C) 2001,2002 by Information-technology Promotion Agency, JAPAN
 *  Copyright (C) 2001,2002 by TRON Association, JAPAN
 * 
 *  based on TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  (1)(4)ξ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 */



#include <jsp_services.h>
#include "kernel_id.h"
#include "sample.h"

extern void	*_kernel_runtsk;


Inline ER
probe_memory(VP base, SIZE size, ID domid, ID tskid, MODE pmmode)
{
#if !defined(__ghs__)
	CAL_SVC_5(ER, TFN_PROBE_MEMORY, VP, base, SIZE, size, ID, domid, ID, tskid, MODE, pmmode);
#else /* defined(__ghs__) */
	return (ER)CAL_SVC_5(TFN_PROBE_MEMORY, base, size, domid, tskid, pmmode);
#endif /* !defined(__ghs__) */
}

/*
 *  롼ײ
 */
int	tex_loop;
/*
 *  Ȳ
 */
int cont = 0;

/*
 *  ǥХåؤΥޥ
 */
int	debug_info = 0;


/*
 sssssssssssssssss ɾѼ롼 sssssssssssssss
 */

/*
 *  ͥɥᥤ󡡥㳰 */

void	kernel_tex(TEXPTN texptn, VP_INT exinf)
{
	t_pline("!!!!!!!! kernel_tex !!!!!!!!");

	switch( texptn )
	{
		case	1:
			privileged_instructions();
			break;
		default:
			break;
	}

}

/*
 *  ;ģϣͣΤߥ
 *  ͥ١MID_PRIORITY
 */

void	task99(VP_INT code)
{

	exec_svc(code);

	ext_tsk();

}

/*
 eeeeeeeeeeeeeeeee ɾѼ롼 eeeeeeeeeeeeees
 */


/*
 *****************  ʲ¸ץ롼 ******************
 */


/*
 *  ¹ԤƼ¹Ԥ륿ѤΥ㳰
 */
void tex_routine(TEXPTN texptn, VP_INT exinf)
{
	INT	i;
	INT	tskno = (INT) exinf;

	syslog(LOG_NOTICE, "task%d receives exception 0x%04x. ",
					tskno, texptn);
	for (i = 0; i < tex_loop; i++);

	if (texptn & 0x8000) {
		syslog(LOG_INFO, "#%d#ext_tsk()", tskno);
		ext_tsk();
	}
}

/*
 *  CPU㳰ϥɥ
 */
void
cpuexc_handler(VP p_excinf)
{
	ID	tskid;

	syslog(LOG_NOTICE, "CPU exception handler (p_excinf = %08x).",
							 p_excinf);
	syslog(LOG_NOTICE, "sns_ctx = %d sns_dpn = %d sns_dsp = %d sns_loc = %d sns_tex = %d", sns_ctx(), sns_dpn(), sns_dsp(), sns_loc(), sns_tex());
	syslog(LOG_NOTICE, "sns_ker = %d xsns_dpn = %d xsns_xpn = %d", sns_ker(), xsns_dpn(p_excinf), xsns_xpn(p_excinf));
	if (sns_ctx() != TRUE) {
		syslog(LOG_WARNING,
			"sns_ctx() is not TRUE in CPU exception handler.");
	}
	if (sns_dpn() != TRUE) {
		syslog(LOG_WARNING,
			"sns_dpn() is not TRUE in CPU exception handler.");
	}
	syslog(LOG_DEBUG,
		"sns_loc = %d sns_dsp = %d", sns_loc(), sns_dsp());

	if(test_2_1_3_flg==1){
		if(iact_tsk(TASK3_EXIT)!=E_OK){
			while(1);
		}
	}

	if (!xsns_xpn(p_excinf)) {
		syscall(iget_tid(&tskid));
		syscall(iras_tex(tskid, 0x8000));

/*				Del	02/02/18-2
		if( pi_flag )
			privileged_instructions();
*/

	}
	else {
		syslog(LOG_NOTICE, "Sample task ends with exception.");
		kernel_exit();
	}

		/*	Please Insert privileged instructions	BY ELMIC	*/

		ena_tex();
		TOKKEN_TST();
		dis_tex();
		/*		Mod	02/02/18-02				*/

}


/*
 *  ꥢȿϥɥ
 */
void
mav_handler(VP p_excinf)
{
	ID	tskid;

	syslog(LOG_NOTICE, "Memory access violation (p_excinf = %08x).",
							 p_excinf);
	syslog(LOG_NOTICE, "sns_ctx = %d sns_dpn = %d sns_dsp = %d sns_loc = %d sns_tex = %d", sns_ctx(), sns_dpn(), sns_dsp(), sns_loc(), sns_tex());
	syslog(LOG_NOTICE, "sns_ker = %d xsns_dpn = %d xsns_xpn = %d", sns_ker(), xsns_dpn(p_excinf), xsns_xpn(p_excinf));
/*
	syslog(LOG_NOTICE, "PC=%08x SSW=%04x FA=%08x",
				*((UW *)(((VB *) p_excinf) + 0x02)),
				*((UH *)(((VB *) p_excinf) + 0x0c)),
				*((UW *)(((VB *) p_excinf) + 0x14)));	*/

	if (!xsns_xpn(p_excinf)) {
		syscall(iget_tid(&tskid));
		syslog(LOG_NOTICE, "tskid=%d", tskid);
		syscall(iras_tex(tskid, 0x8000));

/*				Del	02/02/18-2
		if( pi_flag )
			privileged_instructions();
*/

	}
	else {
		syslog(LOG_NOTICE, "Sample task ends with exception.");
		kernel_exit();
	}

		/*	Please Insert privileged instructions	BY ELMIC	*/

		ena_tex();
		TOKKEN_TST();
		dis_tex();
//		tokken_test();
		/*		Mod	02/02/18-02				*/

}


/*
 * ưϥɥ
 */
void cyclic_handler(VP_INT exinf)
{

}

#if 0
#define	TNUM_BLK_LIST	10
static VP	blk_list[TNUM_BLK_LIST];

void call_pget_mpp(UINT size)
{
	VP	blk;
	UINT	i;

	syslog(LOG_INFO, "#pget_mpp(1, %d)", size);
	syscall(size = pget_mpp(1, size, &blk));
	for (i = 0; i < TNUM_BLK_LIST; i++) {
		if (blk_list[i] == 0) {
			blk_list[i] = blk;
			break;
		}
	}
	syslog(LOG_INFO, "  size=%d blk=%x", size, blk);
}

void call_rel_mpp(UINT index)
{
	VP	blk;

	blk = blk_list[index];
	blk_list[index] = 0;
	syslog(LOG_INFO, "#rel_mpp(1, %x)", blk);
	syscall(rel_mpp(1, blk));
}

void call_snd_mbp(ID mbpid, UINT index)
{
	VP	blk;

	blk = blk_list[index];
	blk_list[index] = 0;
	syslog(LOG_INFO, "#snd_mbp(%d, %x)", mbpid, blk);
	syscall(snd_mbp(mbpid, blk, index + 1));
}

void call_prcv_mbp(ID mbpid)
{
	VP	blk;
	UINT	size, i;

	syslog(LOG_INFO, "#prcv_mbp(%d)", mbpid);
	syscall(size = prcv_mbp(mbpid, &blk));
	for (i = 0; i < TNUM_BLK_LIST; i++) {
		if (blk_list[i] == 0) {
			blk_list[i] = blk;
			break;
		}
	}
	syslog(LOG_INFO, "  size=%d blk=%x", size, blk);
}


#undef kernel_exit
#include "../kernel/jsp_kernel.h"
#include "../kernel/memory.h"
#include "../kernel/mempprot.h"
#include "../kernel/mboxprot.h"
#include <jsp_services.h>
extern MPPCB	mppcb_table[];
extern MBPCB	mbpcb_table[];
extern const char	*itron_strerror(ER ercd);

void access_check_addr(VP addr, UINT size)
{
	ER	ercd1, ercd2, ercd3;

	ercd1 = probe_memory((VP) addr, size, 1, MAIN_TASK, TPM_READ);
	ercd2 = probe_memory((VP) addr, size, 1, MAIN_TASK, TPM_WRITE);
	ercd3 = probe_memory((VP) addr, size, 1, MAIN_TASK, TPM_READ|TPM_WRITE);
	syslog(LOG_INFO, "addr=%x read=%s write=%s rw=%s", addr,
			itron_strerror(ercd1),itron_strerror(ercd2),
			itron_strerror(ercd3));
	dly_tsk(10);
}

void access_check(UINT size)
{
	UW	addr;

	for (addr = 0x10000; addr < 0x20000; addr += 0x1000) {
		access_check_addr((VP) addr, size);
	}
	dly_tsk(1000);
	for (addr = 0x106000; addr < 0x116000; addr += 0x1000) {
		access_check_addr((VP) addr, size);
	}
	dly_tsk(1000);
	for (addr = ((UW) mpp_area); addr < ((UW) mpp_area) + 0x10000;
							addr += 0x1000) {
		access_check_addr((VP) addr, size);
	}
}

void mpp_check()
{
	UINT	i;
	INT	expect;
	MPPCB	*mppcb;
	MBPCB	*mbpcb;
	MBPNODE	*mbpnode;

	syslog(LOG_NOTICE, "BLK_LIST:");
	for (i = 0; i < TNUM_BLK_LIST; i++) {
		if (blk_list[i] != 0) {
			syslog(LOG_NOTICE, "%d: %x", i, blk_list[i]);
		}
	}

	syslog(LOG_NOTICE, "MMPINFO:");
	expect = 0;
	for (i = 0; i < tnum_mpppage; i++) {
		INT	info;
		ACPTN	acptn;
		char	stat;

		info = mppinfo_table[i].info;
		acptn = mppinfo_table[i].acptn;
		if (info >= 0) {
			if ((info & MPP_ALLOCATED) != 0) {
				if ((info & MPP_MAILBOX) != 0) {
					stat = 'M';
				}
				else {
					stat = 'A';
				}
			}
			else {
				stat = 'F';
			}
			syslog(LOG_NOTICE, "%d: %c blk=%x size=%d acptn=%x",
				i, (int) stat, mpp_area + PAGE_SIZE * i,
				((UINT) info) & MPP_SIZE_MASK, acptn);
			expect = -1;
		}
		else {
			if (info == expect) {
				expect--;
			}
			else {
				syslog(LOG_NOTICE, "%d: X %d", i, info);
			}
		}
	}
	dly_tsk(10);

	syslog(LOG_NOTICE, "MMPCB 1:");
	mppcb = &(mppcb_table[0]);
	syslog(LOG_NOTICE, "levelmap: %x", mppcb->levelmap);
	for (i = 0; i < TNUM_MPPLEVEL; i++) {
		QUEUE	*queue;

		queue = mppcb->free_queue[i].next;
		while (queue != &(mppcb->free_queue[i])) {
			syslog(LOG_NOTICE, "level=%d blk=%x", i, queue);
			queue = queue->next;
		}
	}
	dly_tsk(10);

	syslog(LOG_NOTICE, "MBPCB 1:");
	mbpcb = &(mbpcb_table[0]);
	mbpnode = mbpcb->head;
	while (mbpnode != NULL) {
		syslog(LOG_NOTICE, "blkidx=%d msgpri=%d",
				mbpnode->blkidx, mbpnode->msgpri);
		mbpnode = mbpnode->next;
	}
	dly_tsk(10);

	syslog(LOG_NOTICE, "MBPCB 2:");
	mbpcb = &(mbpcb_table[1]);
	mbpnode = mbpcb->head;
	while (mbpnode != NULL) {
		syslog(LOG_NOTICE, "blkidx=%d msgpri=%d",
				mbpnode->blkidx, mbpnode->msgpri);
		mbpnode = mbpnode->next;
	}
}

void debug_task(VP_INT exinf)
{
	if (debug_info == 1) {
		mpp_check();
	}
	else if (debug_info == 2) {
		access_check(1);
	}
	else {
		access_check(0x1800);
	}
}


int test_trap(void);
int test_o1(void);

int
test_trap(void)
{
	CAL_SVC_1(ER, -8, 0x02);
}


int
test_01(void)
{
	return 0;
}
#else /* patch */
#endif

