/*
 *  IIMP Kernel
 *      An Implementation of ITRON with Memory Protection
 * 
 *  Copyright (C) 2001,2002 by Information-technology Promotion Agency, JAPAN
 *  Copyright (C) 2001,2002 by TRON Association, JAPAN
 * 
 *  based on TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  (1)(4)ξ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 */



#include <jsp_services.h>
#include "kernel_id.h"
#include "sample.h"

INT	dom1_mem;

/*
#define	NOTEST_MPP_MBP
*/


/************* DOM1 **************/


/*
 *  ɥᥤ󣱡㳰͠*/

void	dom1_tex(TEXPTN texptn, VP_INT exinf)
{
ER	err_code;

	t_pline(">>>>>>>> dom1_tex --------");

	switch( texptn )
	{
		case	1:
			syslog(LOG_NOTICE, "dom1_tex's auto-variable address = %08x).", (VW)&err_code );
			break;

		default:
			break;
	}

	t_pline("-------- dom1_tex >>>>>>>>");

}


void	task2_tex(TEXPTN texptn, VP_INT exinf)
{

	t_pline(">>>>>>>> task2_tex --------");

	t_pline("task2 own exit");

	ext_tsk();


	t_pline("-------- task2_tex >>>>>>>>");

}


/*
 *  ɥᥤ󣱼ϥɥ */

void dom1_cyc(VP_INT exinf)
{
	t_pline(">>>>>>>> dom1_cyc --------");

	privileged_instructions();

	t_pline("-------- dom1_cyc >>>>>>>>");
}


/*
 *  ;ģϣͣΥ
 */

void	task1(VP_INT code)
{

	while(1)
	{

	test_1_1_1();
	test_1_1_2();
	test_1_1_3();

	test_2_1_1();
	test_2_1_2();
	test_2_1_3();
	test_2_1_4();
	test_2_1_5();

	test_2_2_1();
	test_2_3_1();
	test_2_3_2();

	test_3_2_1();
	test_3_2_2();

	test_3_4_1();
	test_3_4_2();

	test_4_2_1();
	test_4_2_2();

	test_4_3_1();
	test_4_3_2();
	test_4_3_3();

	test_4_4_1();
	test_4_4_2();
	test_4_4_3();

	test_4_5_1();
	test_4_5_2();
	test_4_5_3();

	test_4_6_1();
	test_4_6_2();
	test_4_6_3();

	test_4_7_1();
	test_4_7_2();
	test_4_7_3();

	test_4_8_1();

	test_5_1_1();
	test_5_2_1();



#if 0
	test_6_1_1();

	test_6_3_1();
	test_6_3_2();
	test_6_3_3();
	test_6_3_4();
	test_6_3_5();

	test_6_5_1();
	test_6_5_2();
	test_6_5_3();
	test_6_5_4();
	test_6_5_5();
	test_6_5_6();
	test_6_6_1();
	test_6_6_2();
	test_6_6_3();
	test_6_6_4();
	test_6_6_5();
	test_6_6_6();
	test_6_6_7();
	test_6_6_8();
	test_6_7_1();
	test_6_7_2();
	test_6_7_3();
	test_6_7_4();
	test_6_7_5();
	test_6_7_6();
	test_6_7_7();
	test_6_7_8();
	test_6_7_9();
	test_6_7_10();
	test_6_7_11();

	test_6_8_1();
	test_6_8_2();
	test_6_8_3();

	test_7_2_1();
	test_7_2_2();

	test_7_4_1();
	test_7_4_2();
	test_7_4_3();
	test_7_4_4();
	test_7_4_5();
	test_7_4_6();
	test_7_4_7();
	test_7_4_8();

	test_7_5_1();
	test_7_5_2();
	test_7_5_3();
	test_7_5_4();
	test_7_5_5();
	test_7_5_6();
	test_7_5_7();

	test_7_6_1();
	test_7_6_2();
	test_7_6_3();
	test_7_6_4();
	test_7_6_5();
	test_7_6_6();
	test_7_6_7();
	test_7_6_8();
	test_7_6_9();
	test_7_6_10();
	test_7_6_11();

	test_7_8_1();
	test_7_8_2();
	test_7_8_3();
	test_7_8_4();
	test_7_8_5();

	test_7_9_1();
	test_7_9_2();
	test_7_9_3();
#else /* patch */
#endif



	test_8_1_1();
	test_8_2_1();

	}

	ext_tsk();
}


/*
 *  ;ģϣͣΤߥ
 *  ͥ١MID_PRIORITY
 */

void	task2(VP_INT code)
{

ACT_MENU	*act_menu;
VP		*pt;
static		INT	dummy;


	act_menu = (ACT_MENU *)code;

	if( act_menu->menu < 0 )
	{
		ena_tex();
		switch(act_menu->menu)
		{
			case	-1:				/*	Privilege Instruction	*/
				privileged_instructions();
				break;
			case	-2:				/*	Invalid Read		*/
//				ena_tex();
				pt = (VP) KNL_ADDR_RW;
				dummy = *((INT *) pt);
				break;
			case	-3:
//				ena_tex(); 			/*	Invalid Write		*/
				pt = (VP) KNL_ADDR_RW;
				(*(INT *) pt) = dummy;
				break;
		}
		dis_tex();
	}
	else
	{
		exec_svc(code);
	}

	ext_tsk();

}


/*
 *  ᥤ󥿥
 */

void main_task(VP_INT exinf)
{

#if 0
	serial_ioctl(0, (IOCTL_CRLF | IOCTL_RAW | IOCTL_IXON | IOCTL_IXOFF));
#else /* patch */
#endif

	/* init. all task-event-value */
	ref_tsk_init();

	act_tsk(TASK1);

	slp_tsk();

	syslog(LOG_NOTICE, "Test task ends.");
	kernel_exit();

}
