/*
 *  IIMP Kernel
 *      An Implementation of ITRON with Memory Protection
 * 
 *  Copyright (C) 2001,2002 by Information-technology Promotion Agency, JAPAN
 *  Copyright (C) 2001,2002 by TRON Association, JAPAN
 * 
 *  based on TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  (1)(4)ξ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 */


#include <jsp_services.h>
#include "kernel_id.h"
#include "sample.h"

INT	dom2_mem;

/************* DOM2 **************/

/*
 *  ɥᥤ 㳰͠*/

void	dom2_tex(TEXPTN texptn, VP_INT exinf)
{
#if 0
	ER	err;
#else /* patch */
#endif
	
	t_pline(">>>>>>>> dom2tex --------");

	switch( texptn )
	{
		case	1:
			privileged_instructions();
			break;
		default:
			t_pline("task own exit");		/*	Add	02/02/20	*/
			ext_tsk();				/*	Add	02/02/20	*/
			break;
	}

	t_pline("-------- dom2_tex >>>>>>>>");

}



/*
 *  ɥᥤ󣲼ϥɥ */

void dom2_cyc(VP_INT exinf)
{
	t_pline(">>>>>>>> dom2_cyc --------");

	privileged_instructions();

	t_pline("-------- dom2_cyc >>>>>>>>");

}

/*
 *  ;ģϣͣΥ
 *  ͥ١MID_PRIORITY
 */

void	task3(VP_INT code)
{
	exec_svc(code);

	ext_tsk();

}

void	task3_exit(VP_INT code)
{
	
	if((ter_tsk(TASK3))==E_OK){
		test_2_1_3_flg = 0;
		ref_tsk_event(TASK3, -1);
	}
	ext_tsk();
}
